<?php
/* Copyright (C) 2020      Open-DSI             <support@open-dsi.fr>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

/**
 *	\file       htdocs/requestmanager/lib/requestmanager_init.lib.php
 * 	\ingroup	requestmanager
 *	\brief      Functions for the initialization of the module requestmanager
 */

/**
 * Prepare array with list of SQL
 *
 * @return  array				SQL array to init
 */
function requestmanager_sql()
{
	$res = dol_include_once('/advancedui/class/advancedui.class.php');
	if (!$res) return array();

	$requestmanager_offset = 1000;

	//--------------------------------------------------------------------------------------------------------------
	// Elements
	//--------------------------------------------------------------------------------------------------------------
	$idx = AdvancedUi::DICTIONARY_CUSTOM_LINE_INDEX_BEGIN + $requestmanager_offset;
	$elements = array();
	// Fields table
	$elements[] = array(
		'rowid',		'label',					'lang');
	// Contacts
	$elements = array_merge($elements, array(
		array($idx++,	'RequestManagerRequest',	'requestmanager@requestmanager'),
	));
	$last_elements_id = $idx;
	//--------------------------------------------------------------------------------------------------------------
	// Elements infos
	//--------------------------------------------------------------------------------------------------------------
	$idx = AdvancedUi::DICTIONARY_CUSTOM_LINE_INDEX_BEGIN + $requestmanager_offset;
	$idx_element = AdvancedUi::DICTIONARY_CUSTOM_LINE_INDEX_BEGIN + $requestmanager_offset;
	$elements_infos = array();
	// Fields table
	$elements_infos[] = array(
		'rowid',		'fk_element',	'min_dol_version',	'max_dol_version',	'element_type',		'table_element',	'class_name',		'class_path',										'parameters',																																																																																																																																																																													'new_label',	'new_lang');
	// Contacts
	$elements_infos = array_merge($elements_infos, array(
		array($idx++,	$idx_element++,	'*',				'*',				'requestmanager',	'requestmanager',	'RequestManager',	'/requestmanager/class/requestmanager.class.php',	'{"tab": {"type": "requestmanager", "parameterNameId": "id", "parameterNameRef": "ref", "objectTriggerModify": "REQUESTMANAGER_MODIFY"},  "restrictedArea": {"features": "requestmanager"},  "header": {"title": "RequestManagerRequest", "helpUrl": "EN:Request_Manager_En|FR:Request_Manager_Fr|ES:Request_Manager_Es"}, "ficheHead": {"prepareHeadFunction": "requestmanager_prepare_head", "prepareHeadFilepath": "/requestmanager/lib/requestmanager.lib.php", "title": "RequestManagerCard", "noTab": "-1", "picto": "requestmanager@requestmanager"}, "bannerTab": {"paramId": "ref", "linkBack": "/requestmanager/list.php", "fieldId": "ref"}, "extrafieldsTriggerModify": "REQUESTMANAGER_EXTRAFIELDS_ADD_UPDATE"}',	'',				''),
	));
	$last_elements_infos_id = $idx;
	//--------------------------------------------------------------------------------------------------------------
	// Elements fields
	//--------------------------------------------------------------------------------------------------------------
	$idx = AdvancedUi::DICTIONARY_CUSTOM_LINE_INDEX_BEGIN + $requestmanager_offset;
	$idx_element = AdvancedUi::DICTIONARY_CUSTOM_LINE_INDEX_BEGIN + $requestmanager_offset;
	$elements_fields = array();
	// Fields table
	$elements_fields[] = array(
		'rowid',		'fk_element',	'label',									'lang');
	// Contacts
	$elements_fields = array_merge($elements_fields, array(
		array($idx++,	$idx_element,	'Ref',										''),
		array($idx++,	$idx_element,	'RequestManagerExternalReferenceShort',		'requestmanager@requestmanager'),
		array($idx++,	$idx_element,	'RequestManagerType',						'requestmanager@requestmanager'),
		array($idx++,	$idx_element,	'RequestManagerCategory',					'requestmanager@requestmanager'),
		array($idx++,	$idx_element,	'RequestManagerLabel',						'requestmanager@requestmanager'),
		array($idx++,	$idx_element,	'RequestManagerThirdPartyOrigin',			'requestmanager@requestmanager'),
		array($idx++,	$idx_element,	'RequestManagerRequesterContacts',			'requestmanager@requestmanager'),
		array($idx++,	$idx_element,	'RequestManagerDescription',				'requestmanager@requestmanager'),
		array($idx++,	$idx_element,	'RequestManagerSource',						'requestmanager@requestmanager'),
		array($idx++,	$idx_element,	'RequestManagerUrgency',					'requestmanager@requestmanager'),
		array($idx++,	$idx_element,	'RequestManagerImpact',						'requestmanager@requestmanager'),
		array($idx++,	$idx_element,	'RequestManagerPriority',					'requestmanager@requestmanager'),
		array($idx++,	$idx_element,	'RequestManagerEstimatedDuration',			'requestmanager@requestmanager'),
		array($idx++,	$idx_element,	'RequestManagerEffectiveDuration',			'requestmanager@requestmanager'),
		array($idx++,	$idx_element,	'RequestManagerReportedProgress',			'requestmanager@requestmanager'),
		array($idx++,	$idx_element,	'RequestManagerCalculatedProgression',		'requestmanager@requestmanager'),
		array($idx++,	$idx_element,	'RequestManagerEffectiveCost',				'requestmanager@requestmanager'),
		array($idx++,	$idx_element,	'RequestManagerOperation',					'requestmanager@requestmanager'),
		array($idx++,	$idx_element,	'RequestManagerDeadline',					'requestmanager@requestmanager'),
		array($idx++,	$idx_element,	'RequestManagerRequesterNotification',		'requestmanager@requestmanager'),
		array($idx++,	$idx_element,	'RequestManagerWatcherNotification',		'requestmanager@requestmanager'),
		array($idx++,	$idx_element,	'RequestManagerPlanningUsersInCharge',		'requestmanager@requestmanager'),
		array($idx++,	$idx_element,	'RequestManagerAssignedUsers',				'requestmanager@requestmanager'),
		array($idx++,	$idx_element,	'RequestManagerAssignedUserGroups',			'requestmanager@requestmanager'),
		array($idx++,	$idx_element,	'RequestManagerAssignedNotification',		'requestmanager@requestmanager'),
		array($idx++,	$idx_element,	'RequestManagerReasonResolution',			'requestmanager@requestmanager'),
		array($idx++,	$idx_element,	'RequestManagerReasonResolutionDetails',	'requestmanager@requestmanager'),
		array($idx++,	$idx_element,	'RequestManagerResolvedBy',					'requestmanager@requestmanager'),
		array($idx++,	$idx_element,	'ClosedBy',									''),
		array($idx++,	$idx_element,	'RequestManagerDateResolved',				'requestmanager@requestmanager'),
		array($idx++,	$idx_element,	'DateClosing',								''),
		array($idx++,	$idx_element,	'Author',									''),
		array($idx++,	$idx_element,	'ModifiedBy',								''),
		array($idx++,	$idx_element,	'DateCreation',								''),
		array($idx++,	$idx_element,	'DateModificationShort',					''),
		array($idx++,	$idx_element,	'Status',									''),
	));
	$last_elements_fields_id = $idx;
	//--------------------------------------------------------------------------------------------------------------
	// Elements fields infos
	//--------------------------------------------------------------------------------------------------------------
	$idx = AdvancedUi::DICTIONARY_CUSTOM_LINE_INDEX_BEGIN + $requestmanager_offset;
	$idx_element = AdvancedUi::DICTIONARY_CUSTOM_LINE_INDEX_BEGIN + $requestmanager_offset;
	$idx_element_field = AdvancedUi::DICTIONARY_CUSTOM_LINE_INDEX_BEGIN + $requestmanager_offset;
	$elements_fields_infos = array();
	// Fields table
	$elements_fields_infos[] = array(
		'rowid',		'fk_element',	'fk_element_field',		'min_dol_version',	'max_dol_version',	'position',		'class_field_name',				'table_field_name',				'type',				'parameters',												'new_label',	'new_lang');
	// Contacts
	$elements_fields_infos = array_merge($elements_fields_infos, array(
		array($idx++,	$idx_element,	$idx_element_field++,	'*',				'*',				'1',			'ref',							'ref',							'varchar',			'{"maxLength": 30, "readonly": 1}',							'',				''),
		array($idx++,	$idx_element,	$idx_element_field++,	'*',				'*',				'2',			'ref_ext',						'ref_ext',						'varchar',			'{"maxLength": 30}',										'',				''),
		array($idx++,	$idx_element,	$idx_element_field++,	'*',				'*',				'3',			'fk_type',						'fk_type',						'sellist',			'{"readonly": 1}',											'',				''),
		array($idx++,	$idx_element,	$idx_element_field++,	'*',				'*',				'6',			'fk_category',					'fk_category',					'sellist',			'{"readonly": 1}',											'',				''),
		array($idx++,	$idx_element,	$idx_element_field++,	'*',				'*',				'4',			'label',						'label',						'varchar',			'{"maxLength": 255}',										'',				''),
		array($idx++,	$idx_element,	$idx_element_field++,	'*',				'*',				'5',			'fk_soc',						'fk_soc',						'company',			'',															'',				''),
		array($idx++,	$idx_element,	$idx_element_field++,	'*',				'*',				'7',			'requester_contacts',			'',								'',					'{"readonly": 1}',											'',				''),
		array($idx++,	$idx_element,	$idx_element_field++,	'*',				'*',				'8',			'description',					'description',					'text',				'',															'',				''),
		array($idx++,	$idx_element,	$idx_element_field++,	'*',				'*',				'9',			'fk_source',					'fk_source',					'sellist',			'{"readonly": 1}',											'',				''),
		array($idx++,	$idx_element,	$idx_element_field++,	'*',				'*',				'10',			'fk_urgency',					'fk_urgency',					'sellist',			'{"readonly": 1}',											'',				''),
		array($idx++,	$idx_element,	$idx_element_field++,	'*',				'*',				'11',			'fk_impact',					'fk_impact',					'sellist',			'{"readonly": 1}',											'',				''),
		array($idx++,	$idx_element,	$idx_element_field++,	'*',				'*',				'12',			'fk_priority',					'fk_priority',					'sellist',			'{"readonly": 1}',											'',				''),
		array($idx++,	$idx_element,	$idx_element_field++,	'*',				'*',				'13',			'estimated_duration',			'estimated_duration',			'',					'{"readonly": 1}',											'',				''),
		array($idx++,	$idx_element,	$idx_element_field++,	'*',				'*',				'14',			'effective_duration',			'effective_duration',			'',					'{"readonly": 1}',											'',				''),
		array($idx++,	$idx_element,	$idx_element_field++,	'*',				'*',				'15',			'reported_progress',			'reported_progress',			'',					'{"readonly": 1}',											'',				''),
		array($idx++,	$idx_element,	$idx_element_field++,	'*',				'*',				'16',			'calculated_progression',		'',								'',					'{"readonly": 1}',											'',				''),
		array($idx++,	$idx_element,	$idx_element_field++,	'*',				'*',				'17',			'effective_cost',				'effective_cost',				'',					'{"readonly": 1}',											'',				''),
		array($idx++,	$idx_element,	$idx_element_field++,	'*',				'*',				'18',			'date_operation',				'date_operation',				'datetime',			'',															'',				''),
		array($idx++,	$idx_element,	$idx_element_field++,	'*',				'*',				'19',			'date_deadline',				'date_deadline',				'datetime',			'',															'',				''),
		array($idx++,	$idx_element,	$idx_element_field++,	'*',				'*',				'20',			'notify_requester_by_email',	'notify_requester_by_email',	'boolean',			'',															'',				''),
		array($idx++,	$idx_element,	$idx_element_field++,	'*',				'*',				'21',			'notify_watcher_by_email',		'notify_watcher_by_email',		'boolean',			'',															'',				''),
		array($idx++,	$idx_element,	$idx_element_field++,	'*',				'*',				'22',			'users_in_charge',				'',								'',					'{"readonly": 1}',											'',				''),
		array($idx++,	$idx_element,	$idx_element_field++,	'*',				'*',				'23',			'assigned_users',				'',								'',					'{"readonly": 1}',											'',				''),
		array($idx++,	$idx_element,	$idx_element_field++,	'*',				'*',				'24',			'assigned_usergroups',			'',								'',					'{"readonly": 1}',											'',				''),
		array($idx++,	$idx_element,	$idx_element_field++,	'*',				'*',				'25',			'notify_assigned_by_email',		'notify_assigned_by_email',		'boolean',			'',															'',				''),
		array($idx++,	$idx_element,	$idx_element_field++,	'*',				'*',				'26',			'fk_reason_resolution',			'fk_reason_resolution',			'',					'{"readonly": 1}',											'',				''),
		array($idx++,	$idx_element,	$idx_element_field++,	'*',				'*',				'27',			'reason_resolution_details',	'reason_resolution_details',	'text',				'{"readonly": 1}',											'',				''),
		array($idx++,	$idx_element,	$idx_element_field++,	'*',				'*',				'28',			'fk_user_resolved',				'fk_user_resolved',				'',					'{"readonly": 1}',											'',				''),
		array($idx++,	$idx_element,	$idx_element_field++,	'*',				'*',				'29',			'fk_user_closed',				'fk_user_closed',				'',					'{"readonly": 1}',											'',				''),
		array($idx++,	$idx_element,	$idx_element_field++,	'*',				'*',				'30',			'date_resolved',				'date_resolved',				'datetime',			'{"readonly": 1}',											'',				''),
		array($idx++,	$idx_element,	$idx_element_field++,	'*',				'*',				'31',			'date_cloture',					'date_cloture',					'datetime',			'{"readonly": 1}',											'',				''),
		array($idx++,	$idx_element,	$idx_element_field++,	'*',				'*',				'32',			'fk_user_author',				'fk_user_author',				'',					'{"readonly": 1}',											'',				''),
		array($idx++,	$idx_element,	$idx_element_field++,	'*',				'*',				'33',			'fk_user_modif',				'fk_user_modif',				'',					'{"readonly": 1}',											'',				''),
		array($idx++,	$idx_element,	$idx_element_field++,	'*',				'*',				'34',			'date_creation',				'datec',						'datetime',			'{"readonly": 1}',											'',				''),
		array($idx++,	$idx_element,	$idx_element_field++,	'*',				'*',				'35',			'date_modification',			'tms',							'datetime',			'{"readonly": 1}',											'',				''),
		array($idx++,	$idx_element,	$idx_element_field++,	'*',				'*',				'36',			'statut',						'fk_status',					'',					'{"readonly": 1}',											'',				''),
	));
	$last_elements_fields_infos_id = $idx;
	//--------------------------------------------------------------------------------------------------------------
	// Lists
	//--------------------------------------------------------------------------------------------------------------
	$idx = AdvancedUi::DICTIONARY_CUSTOM_LINE_INDEX_BEGIN + $requestmanager_offset;
	$idx_element = AdvancedUi::DICTIONARY_CUSTOM_LINE_INDEX_BEGIN + $requestmanager_offset;
	$lists = array();
	// Fields table
	$lists[] = array(
		'rowid',		'fk_element',	'label',						'lang');
	// Contacts
	$lists = array_merge($lists, array(
		array($idx++,	$idx_element++,	'RequestManagerListOfRequests',	'requestmanager@requestmanager'),
	));
	$last_lists_id = $idx;
	//--------------------------------------------------------------------------------------------------------------
	// Lists infos
	//--------------------------------------------------------------------------------------------------------------
	$idx = AdvancedUi::DICTIONARY_CUSTOM_LINE_INDEX_BEGIN + $requestmanager_offset;
	$idx_list = AdvancedUi::DICTIONARY_CUSTOM_LINE_INDEX_BEGIN + $requestmanager_offset;
	$lists_infos = array();
	// Fields table
	$lists_infos[] = array(
		'rowid',		'fk_list',		'min_dol_version',	'max_dol_version',	'context',													'selector',			'new_label',	'new_lang');
	// Contacts
	$lists_infos = array_merge($lists_infos, array(
		array($idx++,	$idx_list++,	'*',				'*',				'context:requestmanagerlist,requestmanagerplanninglist',	'table.liste',		'',				''),
	));
	$last_lists_infos_id = $idx;
	//--------------------------------------------------------------------------------------------------------------
	// Lists fields
	//--------------------------------------------------------------------------------------------------------------
	$idx = AdvancedUi::DICTIONARY_CUSTOM_LINE_INDEX_BEGIN + $requestmanager_offset;
	$idx_list = AdvancedUi::DICTIONARY_CUSTOM_LINE_INDEX_BEGIN + $requestmanager_offset;
	$idx_element_field = AdvancedUi::DICTIONARY_CUSTOM_LINE_INDEX_BEGIN + $requestmanager_offset;
	$lists_fields = array();
	// Fields table
	$lists_fields[] = array(
		'rowid',		'fk_list',		'fk_element_field',		'min_dol_version',	'max_dol_version',	'position',		'list_field_key',				'check_test',	'parameters',			'new_label',	'new_lang');
	// Contacts
	$lists_fields = array_merge($lists_fields, array(
		array($idx++,	$idx_list,		$idx_element_field++,	'*',				'*',				'1',			'rm.ref',						'',				'{"nameUrlField": 1}',	'',				''),
		array($idx++,	$idx_list,		$idx_element_field++,	'*',				'*',				'2',			'rm.ref_ext',					'',				'',						'',				''),
		array($idx++,	$idx_list,		$idx_element_field++,	'*',				'*',				'3',			'rm.fk_type',					'',				'',						'',				''),
		array($idx++,	$idx_list,		$idx_element_field++,	'*',				'*',				'4',			'rm.fk_category',				'',				'',						'',				''),
		array($idx++,	$idx_list,		$idx_element_field++,	'*',				'*',				'5',			'rm.label',						'',				'',						'',				''),
		array($idx++,	$idx_list,		$idx_element_field++,	'*',				'*',				'6',			'rm.fk_soc',					'',				'',						'',				''),
		array($idx++,	$idx_list,		$idx_element_field++,	'*',				'*',				'7',			'requester_contacts',			'',				'',						'',				''),
		array($idx++,	$idx_list,		$idx_element_field++,	'*',				'*',				'8',			'rm.description',				'',				'',						'',				''),
		array($idx++,	$idx_list,		$idx_element_field++,	'*',				'*',				'9',			'rm.fk_source',					'',				'',						'',				''),
		array($idx++,	$idx_list,		$idx_element_field++,	'*',				'*',				'10',			'rm.fk_urgency',				'',				'',						'',				''),
		array($idx++,	$idx_list,		$idx_element_field++,	'*',				'*',				'11',			'rm.fk_impact',					'',				'',						'',				''),
		array($idx++,	$idx_list,		$idx_element_field++,	'*',				'*',				'12',			'rm.fk_priority',				'',				'',						'',				''),
		array($idx++,	$idx_list,		$idx_element_field++,	'*',				'*',				'13',			'rm.estimated_duration',		'',				'',						'',				''),
		array($idx++,	$idx_list,		$idx_element_field++,	'*',				'*',				'14',			'rm.effective_duration',		'',				'',						'',				''),
		array($idx++,	$idx_list,		$idx_element_field++,	'*',				'*',				'15',			'rm.reported_progress',			'',				'',						'',				''),
		array($idx++,	$idx_list,		$idx_element_field++,	'*',				'*',				'16',			'calculated_progression',		'',				'',						'',				''),
		array($idx++,	$idx_list,		$idx_element_field++,	'*',				'*',				'17',			'rm.effective_cost',			'',				'',						'',				''),
		array($idx++,	$idx_list,		$idx_element_field++,	'*',				'*',				'18',			'rm.date_operation',			'',				'',						'',				''),
		array($idx++,	$idx_list,		$idx_element_field++,	'*',				'*',				'19',			'rm.date_deadline',				'',				'',						'',				''),
		array($idx++,	$idx_list,		$idx_element_field++,	'*',				'*',				'20',			'rm.notify_requester_by_email',	'',				'',						'',				''),
		array($idx++,	$idx_list,		$idx_element_field++,	'*',				'*',				'21',			'rm.notify_watcher_by_email',	'',				'',						'',				''),
		array($idx++,	$idx_list,		$idx_element_field++,	'*',				'*',				'22',			'users_in_charge',				'',				'',						'',				''),
		array($idx++,	$idx_list,		$idx_element_field++,	'*',				'*',				'23',			'assigned_users',				'',				'',						'',				''),
		array($idx++,	$idx_list,		$idx_element_field++,	'*',				'*',				'24',			'assigned_usergroups',			'',				'',						'',				''),
		array($idx++,	$idx_list,		$idx_element_field++,	'*',				'*',				'25',			'rm.notify_assigned_by_email',	'',				'',						'',				''),
		array($idx++,	$idx_list,		$idx_element_field++,	'*',				'*',				'26',			'rm.fk_reason_resolution',		'',				'',						'',				''),
		array($idx++,	$idx_list,		$idx_element_field++,	'*',				'*',				'27',			'rm.reason_resolution_details',	'',				'',						'',				''),
		array($idx++,	$idx_list,		$idx_element_field++,	'*',				'*',				'28',			'rm.fk_user_resolved',			'',				'',						'',				''),
		array($idx++,	$idx_list,		$idx_element_field++,	'*',				'*',				'29',			'rm.fk_user_closed',			'',				'',						'',				''),
		array($idx++,	$idx_list,		$idx_element_field++,	'*',				'*',				'30',			'rm.date_resolved',				'',				'',						'',				''),
		array($idx++,	$idx_list,		$idx_element_field++,	'*',				'*',				'31',			'rm.date_cloture',				'',				'',						'',				''),
		array($idx++,	$idx_list,		$idx_element_field++,	'*',				'*',				'32',			'rm.fk_user_author',			'',				'',						'',				''),
		array($idx++,	$idx_list,		$idx_element_field++,	'*',				'*',				'33',			'rm.fk_user_modif',				'',				'',						'',				''),
		array($idx++,	$idx_list,		$idx_element_field++,	'*',				'*',				'+1',			'rm.datec',						'',				'',						'',				''),
		array($idx++,	$idx_list,		$idx_element_field++,	'*',				'*',				'+2',			'rm.tms',						'',				'',						'',				''),
		array($idx++,	$idx_list,		$idx_element_field++,	'*',				'*',				'+3',			'rm.fk_status',					'',				'',						'',				''),
	));
	$last_lists_fields_id = $idx;

	//--------------------------------------------------------------------------------------------------------------
	// SQL
	//--------------------------------------------------------------------------------------------------------------
	dol_include_once('/advancedui/lib/advancedui.lib.php');
	$sql = array();
	$sql = array_merge($sql, advancedui_array_clean_insert_to_sql('c_advancedui_elements', 'rowid', $last_elements_id, AdvancedUi::DICTIONARY_CUSTOM_LINE_INDEX_BEGIN + $requestmanager_offset));
	$sql = array_merge($sql, advancedui_array_clean_insert_to_sql('c_advancedui_element_infos', 'rowid', $last_elements_infos_id, AdvancedUi::DICTIONARY_CUSTOM_LINE_INDEX_BEGIN + $requestmanager_offset));
	$sql = array_merge($sql, advancedui_array_clean_insert_to_sql('c_advancedui_element_fields', 'rowid', $last_elements_fields_id, AdvancedUi::DICTIONARY_CUSTOM_LINE_INDEX_BEGIN + $requestmanager_offset));
	$sql = array_merge($sql, advancedui_array_clean_insert_to_sql('c_advancedui_element_field_infos', 'rowid', $last_elements_fields_infos_id, AdvancedUi::DICTIONARY_CUSTOM_LINE_INDEX_BEGIN + $requestmanager_offset));
	$sql = array_merge($sql, advancedui_array_clean_insert_to_sql('c_advancedui_lists', 'rowid', $last_lists_id, AdvancedUi::DICTIONARY_CUSTOM_LINE_INDEX_BEGIN + $requestmanager_offset));
	$sql = array_merge($sql, advancedui_array_clean_insert_to_sql('c_advancedui_list_infos', 'rowid', $last_lists_infos_id, AdvancedUi::DICTIONARY_CUSTOM_LINE_INDEX_BEGIN + $requestmanager_offset));
	$sql = array_merge($sql, advancedui_array_clean_insert_to_sql('c_advancedui_list_fields', 'rowid', $last_lists_fields_id, AdvancedUi::DICTIONARY_CUSTOM_LINE_INDEX_BEGIN + $requestmanager_offset));
	$sql = array_merge($sql, advancedui_array_insert_to_sql('c_advancedui_elements', $elements));
	$sql = array_merge($sql, advancedui_array_insert_to_sql('c_advancedui_element_infos', $elements_infos));
	$sql = array_merge($sql, advancedui_array_insert_to_sql('c_advancedui_element_fields', $elements_fields));
	$sql = array_merge($sql, advancedui_array_insert_to_sql('c_advancedui_element_field_infos', $elements_fields_infos));
	$sql = array_merge($sql, advancedui_array_insert_to_sql('c_advancedui_lists', $lists));
	$sql = array_merge($sql, advancedui_array_insert_to_sql('c_advancedui_list_infos', $lists_infos));
	$sql = array_merge($sql, advancedui_array_insert_to_sql('c_advancedui_list_fields', $lists_fields));
	return $sql;
}
