<?php
/* Copyright (C) 2018      Open-DSI              <support@open-dsi.fr>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

/**
 *	\file       	htdocs/requestmanager/list.php
 *	\ingroup    	requestmanager
 *	\brief      	Page of request manager list
 */

// Change this following line to use the correct relative path (../, ../../, etc)
$res=0;
if (! $res && file_exists("../main.inc.php")) $res=@include '../main.inc.php';					// to work if your module directory is into dolibarr root htdocs directory
if (! $res && file_exists("../../main.inc.php")) $res=@include '../../main.inc.php';			// to work if your module directory is into a subdir of root htdocs directory
if (! $res && file_exists("../../../dolibarr/htdocs/main.inc.php")) $res=@include '../../../dolibarr/htdocs/main.inc.php';     // Used on dev env only
if (! $res && file_exists("../../../../dolibarr/htdocs/main.inc.php")) $res=@include '../../../../dolibarr/htdocs/main.inc.php';   // Used on dev env only
if (! $res) die("Include of main fails");
require_once DOL_DOCUMENT_ROOT.'/categories/class/categorie.class.php';
require_once DOL_DOCUMENT_ROOT.'/core/lib/date.lib.php';
require_once DOL_DOCUMENT_ROOT.'/core/class/html.formother.class.php';
require_once DOL_DOCUMENT_ROOT.'/user/class/user.class.php';
require_once DOL_DOCUMENT_ROOT.'/user/class/usergroup.class.php';
require_once DOL_DOCUMENT_ROOT.'/societe/class/societe.class.php';
require_once DOL_DOCUMENT_ROOT.'/contact/class/contact.class.php';
require_once DOL_DOCUMENT_ROOT.'/core/class/extrafields.class.php';
dol_include_once('/requestmanager/class/requestmanager.class.php');
dol_include_once('/requestmanager/class/html.formrequestmanager.class.php');
dol_include_once('/advancedictionaries/class/dictionary.class.php');
dol_include_once('/advancedictionaries/class/html.formdictionary.class.php');
dol_include_once('/requestmanager/lib/requestmanager.lib.php');

$langs->load('requestmanager@requestmanager');

$action=GETPOST('action','alpha');
$massaction=GETPOST('massaction','alpha');
$confirm=GETPOST('confirm','alpha');
$toselect = GETPOST('toselect', 'array');
$request_id = GETPOST('request_id', 'int');

$socid=GETPOST('socid','int');
$contact_id=GETPOST('contact_id','int');

// TODO rajouter la Progression calculée et le Coût éffectif

$sall=GETPOST('sall', 'alphanohtml');
$search_ref=GETPOST('search_ref','alpha');
$search_ref_ext=GETPOST('search_ref_ext','alpha');
$search_type=GETPOST('search_type','alpha');
$search_category=GETPOST('search_category','alpha');
$search_label=GETPOST('search_label','alpha');
$search_thridparty_origin=GETPOST('search_thridparty_origin','alpha');
$search_requester_contacts=GETPOST('search_requester_contacts','alpha');
$search_source=GETPOST('search_source','alpha');
$search_urgency=GETPOST('search_urgency','alpha');
$search_impact=GETPOST('search_impact','alpha');
$search_priority=GETPOST('search_priority','alpha');
//$search_estimated_duration=GETPOST('search_estimated_duration','alpha');
//$search_effective_duration=GETPOST('search_effective_duration','alpha');
//$search_reported_progress=GETPOST('search_reported_progress','alpha');
$search_date_operation=GETPOST('search_date_operation','alpha');
$search_date_deadline=GETPOST('search_date_deadline','alpha');
$search_notify_requester_by_email=GETPOST('search_notify_requester_by_email','int');
$search_notify_watcher_by_email=GETPOST('search_notify_watcher_by_email','int');
$search_assigned_user=GETPOST('search_assigned_user','alpha');
$search_assigned_usergroup=GETPOST('search_assigned_usergroup','alpha');
$search_notify_assigned_by_email=GETPOST('search_notify_assigned_by_email','int');
$search_description=GETPOST('search_description','alpha');
$search_tags=GETPOST('search_tags','array');
$search_reason_resolution=GETPOST('search_reason_resolution','int');
$search_reason_resolution_details=GETPOST('search_reason_resolution_details','alpha');
$search_date_resolved=GETPOST('search_date_resolved','alpha');
$search_date_cloture=GETPOST('search_date_cloture','alpha');
$search_user_resolved=GETPOST('search_user_resolved','alpha');
$search_user_cloture=GETPOST('search_user_cloture','alpha');
$search_date_creation=GETPOST('search_date_creation','alpha');
$search_date_modification=GETPOST('search_date_modification','alpha');
$search_user_author=GETPOST('search_user_author','alpha');
$search_user_modification=GETPOST('search_user_modification','alpha');
$search_dont_show_children_request=GETPOST('search_dont_show_children_request','int');
$search_status_det=GETPOST('search_status_det','array');
$search_in_charge=GETPOST('search_in_charge','array');
$my_list=GETPOST('mylist','int');
$not_assigned=GETPOST('notassigned','int');
$planning=GETPOST('planning','int');
$status_type=GETPOST('status_type','int');
$optioncss = GETPOST('optioncss','alpha');

$limit = GETPOST('limit')?GETPOST('limit','int'):$conf->liste_limit;
$sortfield = GETPOST("sortfield",'alpha');
$sortorder = GETPOST("sortorder",'alpha');
$page = GETPOST("page",'int');
if (empty($page) || $page == -1) { $page = 0; }     // If $page is not defined, or '' or -1
$offset = $limit * $page;
$pageprev = $page - 1;
$pagenext = $page + 1;
if (! $sortfield) $sortfield='rm.ref';
if (! $sortorder) $sortorder='DESC';

// Security check
if (! empty($user->societe_id))	$socid=$user->societe_id;
if (! empty($socid)) {
    $result = restrictedArea($user, 'societe', $socid, '&societe');
}
$result = restrictedArea($user, 'requestmanager', '', '');
if ($planning && !$user->rights->requestmanager->planning->lire) {
    accessforbidden();
}

// Initialize technical object to manage hooks of page. Note that conf->hooks_modules contains array of hook context
$contextpage='requestmanagerlist';
if ($planning) {
    $contextpage='requestmanagerplanninglist';
}

$object = new RequestManager($db);	// To be passed as parameter of executeHooks that need

// Initialize technical object to manage hooks of page. Note that conf->hooks_modules contains array of hook context
$hookmanager->initHooks(array($contextpage));
$extrafields = new ExtraFields($db);

// fetch optionals attributes and labels
$extralabels = $extrafields->fetch_name_optionals_label('requestmanager');
$search_array_options=$extrafields->getOptionalsFromPost($extralabels,'','search_');

// Get planning info
if ($planning) {
    $request_types_planned = !empty($conf->global->REQUESTMANAGER_PLANNING_REQUEST_TYPE) ? explode(',', $conf->global->REQUESTMANAGER_PLANNING_REQUEST_TYPE) : array();
    dol_include_once('/advancedictionaries/class/dictionary.class.php');
    $requestmanagerrequesttype = Dictionary::getDictionary($db, 'requestmanager', 'requestmanagerrequesttype');
    $requestmanagerrequesttype->fetch_lines(1);
}

// List of fields to search into when doing a "search in all"
$fieldstosearchall = array(
    'rm.ref'=>'Ref',
    'rm.ref_ext'=>'RequestManagerExternalReference',
    's.nom'=>"RequestManagerThirdPartyOrigin",
    'rm.label'=>'RequestManagerLabel',
);

$arrayfields = array(
    'rm.ref' => array('label' => $langs->trans("Ref"), 'checked' => 1),
    'rm.ref_ext' => array('label' => $langs->trans("RequestManagerExternalReferenceShort"), 'checked' => 1),
    'rm.fk_type' => array('label' => $langs->trans("RequestManagerType"), 'checked' => 1),
    'rm.fk_category' => array('label' => $langs->trans("RequestManagerCategory"), 'checked' => 1),
    'rm.label' => array('label' => $langs->trans("RequestManagerLabel"), 'checked' => 1),
    'rm.fk_soc' => array('label' => $langs->trans("RequestManagerThirdPartyOrigin"), 'checked' => 1),
	'requester_contacts' => array('label' => $langs->trans("RequestManagerRequesterContacts"), 'checked' => 1),
    'rm.description' => array('label' => $langs->trans("RequestManagerDescription"), 'checked' => 0),
    'rm.fk_source' => array('label' => $langs->trans("RequestManagerSource"), 'checked' => 0),
    'rm.fk_urgency' => array('label' => $langs->trans("RequestManagerUrgency"), 'checked' => 0),
    'rm.fk_impact' => array('label' => $langs->trans("RequestManagerImpact"), 'checked' => 0),
    'rm.fk_priority' => array('label' => $langs->trans("RequestManagerPriority"), 'checked' => 0),
    'rm.estimated_duration' => array('label' => $langs->trans("RequestManagerEstimatedDuration"), 'checked' => 0),
    'rm.effective_duration' => array('label' => $langs->trans("RequestManagerEffectiveDuration"), 'checked' => 0),
    'rm.reported_progress' => array('label' => $langs->trans("RequestManagerReportedProgress"), 'checked' => 0),
    'calculated_progression' => array('label' => $langs->trans("RequestManagerCalculatedProgression"), 'checked' => 0),
    'rm.effective_cost' => array('label' => $langs->trans("RequestManagerEffectiveCost"), 'checked' => 0),
    'rm.date_operation' => array('label' => $langs->trans("RequestManagerOperation"), 'checked' => 0),
    'rm.date_deadline' => array('label' => $langs->trans("RequestManagerDeadline"), 'checked' => 0),
    'rm.notify_requester_by_email' => array('label' => $langs->trans("RequestManagerRequesterNotification"), 'checked' => 0),
    'rm.notify_watcher_by_email' => array('label' => $langs->trans("RequestManagerWatcherNotification"), 'checked' => 0),
    'users_in_charge' => array('label' => $langs->trans("RequestManagerPlanningUsersInCharge"), 'checked' => 1, 'enabled'=> ($planning ? 1 : 0)),
    'assigned_users' => array('label' => $langs->trans("RequestManagerAssignedUsers"), 'checked' => 1),
    'assigned_usergroups' => array('label' => $langs->trans("RequestManagerAssignedUserGroups"), 'checked' => 1),
    'rm.notify_assigned_by_email' => array('label' => $langs->trans("RequestManagerAssignedNotification"), 'checked' => 0, 'enabled'=> (empty($conf->global->REQUESTMANAGER_NOTIFICATION_ASSIGNED_BY_EMAIL) ? 0 : 1)),
    'rm.fk_reason_resolution' => array('label' => $langs->trans("RequestManagerReasonResolution"), 'checked' => 0),
    'rm.reason_resolution_details' => array('label' => $langs->trans("RequestManagerReasonResolutionDetails"), 'checked' => 0),
    'rm.fk_user_resolved' => array('label' => $langs->trans("RequestManagerResolvedBy"), 'checked' => 0, 'position' => 10),
    'rm.fk_user_closed' => array('label' => $langs->trans("ClosedBy"), 'checked' => 0, 'position' => 10),
    'rm.date_resolved' => array('label' => $langs->trans("RequestManagerDateResolved"), 'checked' => 0, 'position' => 10),
    'rm.date_cloture' => array('label' => $langs->trans("DateClosing"), 'checked' => 0, 'position' => 10),
    'rm.fk_user_author' => array('label' => $langs->trans("Author"), 'checked' => 0, 'position' => 10),
    'rm.fk_user_modif' => array('label' => $langs->trans("ModifiedBy"), 'checked' => 0, 'position' => 10),
    'rm.datec' => array('label' => $langs->trans("DateCreation"), 'checked' => 1, 'position' => 500),
    'rm.tms' => array('label' => $langs->trans("DateModificationShort"), 'checked' => 0, 'position' => 500),
    'rm.fk_status' => array('label' => $langs->trans("Status"), 'checked' => 1, 'position' => 1000),
);
// Extra fields
if (version_compare(DOL_VERSION, "13.0.0") >= 0) {
	include DOL_DOCUMENT_ROOT.'/core/tpl/extrafields_list_array_fields.tpl.php';
} else {
	if (is_array($extrafields->attribute_label) && count($extrafields->attribute_label)) {
		foreach ($extrafields->attribute_label as $key => $val) {
			if (!empty($extrafields->attribute_list[$key])) $arrayfields["ef." . $key] = array('label' => $extrafields->attribute_label[$key], 'checked' => (($extrafields->attribute_list[$key] < 0) ? 0 : 1), 'position' => $extrafields->attribute_pos[$key], 'enabled' => (abs($extrafields->attribute_list[$key]) != 3 && $extrafields->attribute_perms[$key]));
		}
	}
}


/*
 * Actions
 */

if (GETPOST('cancel')) { $action='list'; $massaction=''; }
if (! GETPOST('confirmmassaction') &&
	$massaction != 'pre_rm_delete' && $massaction != 'confirm_rm_delete' &&
	$massaction != 'rm_planning' && $massaction != 'confirm_planning' &&
	$massaction != 'pre_rm_send_survey' && $massaction != 'confirm_rm_send_survey') { $massaction=''; }

$parameters=array('socid'=>$socid);
$reshook=$hookmanager->executeHooks('doActions',$parameters,$object,$action);    // Note that $action and $object may have been modified by some hooks
if ($reshook < 0) setEventMessages($hookmanager->error, $hookmanager->errors, 'errors');

include DOL_DOCUMENT_ROOT.'/core/actions_changeselectedfields.inc.php';

// Do we click on purge search criteria ?
if (GETPOST('button_removefilter_x','alpha') || GETPOST('button_removefilter.x','alpha') || GETPOST('button_removefilter','alpha')) // All tests are required to be compatible with all browsers
{
    $search_ref='';
    $search_ref_ext='';
    $search_type='';
    $search_category='';
    $search_label='';
    $search_thridparty_origin='';
	$search_requester_contacts='';
    $search_source='';
    $search_urgency='';
    $search_impact='';
    $search_priority='';
//    $search_estimated_duration='';
//    $search_effective_duration='';
//    $search_reported_progress='';
    $search_date_operation='';
    $search_date_deadline='';
    $search_notify_requester_by_email=-1;
    $search_notify_watcher_by_email=-1;
    $search_assigned_user='';
    $search_assigned_usergroup='';
    $search_notify_assigned_by_email=-1;
    $search_description='';
    $search_tags=array();
    $search_reason_resolution=-1;
    $search_reason_resolution_details='';
    $search_date_resolved='';
    $search_date_cloture='';
    $search_user_resolved='';
    $search_user_cloture='';
    $search_date_creation='';
    $search_date_modification='';
    $search_user_author='';
    $search_user_modification='';
    $search_dont_show_children_request='';
    $status_type=-1;
    $search_in_charge = array();
	$toselect='';
    $search_array_options=array();
    $search_status_det = array();
}
if ($search_notify_requester_by_email === '') $search_notify_requester_by_email = -1;
if ($search_notify_watcher_by_email === '') $search_notify_watcher_by_email = -1;
if ($search_notify_assigned_by_email === '') $search_notify_assigned_by_email = -1;
if ($search_reason_resolution === '') $search_reason_resolution = -1;
if ($status_type === '') $status_type = -1;
if ($planning && count($search_in_charge)) $search_in_charge = array_filter(array_map('trim', $search_in_charge), 'strlen');
if ($planning && empty($search_in_charge) && $my_list) $search_in_charge = array($user->id);
if ($planning && count($search_in_charge) == 1 && in_array($user->id, $search_in_charge)) $my_list = 1;

if (empty($reshook)) {
	$objectclass = 'RequestManager';
	$objectlabel = 'RequestManagerRequests';
	$permtoread = $user->rights->requestmanager->lire;
	$permtocreate = $user->rights->requestmanager->creer;
	$permtodelete = $user->rights->requestmanager->supprimer;
	$uploaddir = $conf->requestmanager->multidir_output[$conf->entity];
	include DOL_DOCUMENT_ROOT . '/core/actions_massactions.inc.php';

	if (! $error && $massaction == 'rm_create_request_and_link' && $permtocreate) {
		if (count($toselect) == 1) {
			$tmp = array_values($toselect);
			$create_params = http_build_query(array('origin' => 'requestmanager', 'originid' => $tmp[0]));
		} else {
			$other_linked_objects = array();
			foreach ($toselect as $toselectid) {
				$other_linked_objects['requestmanager'][$toselectid] = $toselectid;
			}
			$create_params = http_build_query(array('other_linked_objects' => $other_linked_objects));
		}

		header('Location: ' . dol_buildpath('/requestmanager/card.php', 1) . '?action=create&token=' . newToken() . '&' . $create_params);
		exit();
	}

	if (! $error && $massaction == 'rm_create_request_and_link_as_children' && $permtocreate) {
		$children_request = array();
		foreach ($toselect as $toselectid) {
			$children_request[] = $toselectid;
		}
		$children_request = array_flip(array_flip($children_request));
		$create_params = http_build_query(array('children_request' => $children_request));

		header('Location: ' . dol_buildpath('/requestmanager/card.php', 1) . '?action=create&token=' . newToken() . '&' . $create_params);
		exit();
	}

	// Delete request from mass action
	if (! $error && ($massaction == 'confirm_rm_delete' || ($action == 'confirm_rm_delete' && $confirm == 'yes')) && $permtodelete) {
		$delete_event_auto = GETPOST('delete_event_auto', 'aZ09');
		$delete_event_manual = GETPOST('delete_event_manual', 'aZ09');

		$db->begin();

		$request_static = new RequestManager($db);
		$nbok = 0;
		foreach ($toselect as $toselectid) {
			$result = $request_static->fetch($toselectid);
			if ($result > 0) {
				$result = $request_static->delete($user, false, $delete_event_auto, $delete_event_manual);
				if ($result <= 0) {
					setEventMessages($request_static->error, $request_static->errors, 'errors');
					$error++;
					break;
				} else $nbok++;
			} else {
				setEventMessages($request_static->error, $request_static->errors, 'errors');
				$error++;
				break;
			}
		}

		if (!$error) {
			if ($nbok > 1) setEventMessages($langs->trans("RecordsDeleted", $nbok), null, 'mesgs');
			else setEventMessages($langs->trans("RecordDeleted", $nbok), null, 'mesgs');
			$db->commit();
		} else {
			$db->rollback();
		}
	}

	if (!$error) {
		if ($planning) {
			if ($action == 'confirm_planning' && $confirm == 'yes' && $user->rights->requestmanager->planning->manage) {
				$nb_error = 0;
				$date_operation = dol_mktime(GETPOST('operate_datehour', 'int'), GETPOST('operate_datemin', 'int'), 0, GETPOST('operate_datemonth', 'int'), GETPOST('operate_dateday', 'int'), GETPOST('operate_dateyear', 'int'));
				$date_deadline = dol_mktime(GETPOST('deadline_datehour', 'int'), GETPOST('deadline_datemin', 'int'), 0, GETPOST('deadline_datemonth', 'int'), GETPOST('deadline_dateday', 'int'), GETPOST('deadline_dateyear', 'int'));
				$assigned_user_ids = GETPOST('assigned_user_ids', 'array');
				$request_list = GETPOST('request_list', 'array');
				$old_action = GETPOST('old_action', 'alpha');
				$old_massaction = GETPOST('old_massaction', 'alpha');

				if (empty($date_operation)) {
					setEventMessage($langs->trans('ErrorFieldRequired', $langs->transnoentitiesnoconv('RequestManagerOperation')), 'errors');
					$nb_error++;
				}
				if (empty($assigned_user_ids)) {
					setEventMessage($langs->trans('ErrorFieldRequired', $langs->transnoentitiesnoconv('RequestManagerAssignedUsers')), 'errors');
					$nb_error++;
				}

				if (!$nb_error && count($request_list) > 0) {
					foreach ($request_list as $r_id) {
						$error = 0;
						$db->begin();

						$request_static = new RequestManager($db);
						if ($request_static->fetch($r_id) <= 0) $error++;
						if (!($conf->global->{'REQUESTMANAGER_PLANNING_REQUEST_STATUS_PLANNED_' . $request_static->fk_type} > 0)) {
							$request_static->error = $langs->trans('RequestManagerErrorPlanningRequestStatusPlannedNotConfigured');
							$request_static->errors = array();
							$error++;
						}
						if (!$error && $request_static->set_status($conf->global->{'REQUESTMANAGER_PLANNING_REQUEST_STATUS_PLANNED_' . $request_static->fk_type}, -1, $user) <= 0) $error++;
						$request_static->date_operation = $date_operation;
						if ($date_deadline > 0) {
							$request_static->date_deadline = $date_deadline;
						} else {
							// calculate deadline date with operation date or now and the offset deadline time in minutes
							dol_include_once('/advancedictionaries/class/dictionary.class.php');
							$requestManagerStatusDictionaryLine = Dictionary::getDictionaryLine($db, 'requestmanager', 'requestmanagerstatus');
							$res = $requestManagerStatusDictionaryLine->fetch($object->statut);
							if ($res > 0) {
								$deadline_offset = $requestManagerStatusDictionaryLine->fields['deadline'];
								$now = dol_now();
								if (isset($deadline_offset) && $deadline_offset > 0) {
									$object->date_deadline = ($object->date_operation > 0 ? $object->date_operation : $now) + ($deadline_offset * 60);
//                        } elseif (intval($conf->global->REQUESTMANAGER_DEADLINE_TIME_DEFAULT) > 0) {
//                            $object->date_deadline = ($object->date_operation > 0 ? $object->date_operation : $now) + (intval($conf->global->REQUESTMANAGER_DEADLINE_TIME_DEFAULT) * 60);
								}
							} else {
								setEventMessages($requestManagerStatusDictionaryLine->error, $requestManagerStatusDictionaryLine->errors, 'errors');
								$error++;
							}
						}
						$request_static->assigned_user_ids = $assigned_user_ids;
						$request_static->context['rm_planning'] = true;
						if (!$error && $request_static->update($user) <= 0) $error++;

						if (!$error) {
							$db->commit();
						} else {
							setEventMessage($langs->trans('RequestManagerErrorForRequest', !empty($request_static->ref) ? $request_static->ref : 'ID: ' . $r_id), 'errors');
							setEventMessages($request_static->error, $request_static->errors, 'errors');
							$db->rollback();
							$nb_error++;
						}
					}
				}

				if ($nb_error) {
					$action = $old_action;
					$massaction = $old_massaction;
				}
			}
		} else {
			if (isModEnabled('questionnaire') && $action == 'confirm_rm_create_survey' && $confirm == 'yes' && is_array($toselect)) {
				$questionnaire_id = GETPOST('questionnaire_id', 'int');
				$date_answer_deadline = dol_mktime(0, 0, 0, GETPOST('date_answer_deadlinemonth', 'int'), GETPOST('date_answer_deadlineday', 'int'), GETPOST('date_answer_deadlineyear', 'int'));

				$request_static = new RequestManager($db);
				$request_static->loadRequestStatus();

				foreach ($toselect as $r_id) {
					$request_static->fetch($r_id);
					if (empty(RequestManager::$status_list[$request_static->statut]->fields['survey'])) continue;
					$result = $request_static->createSurvey($user, $questionnaire_id, $date_answer_deadline);
					if ($result < 0 || !empty($request_static->errors)) {
						setEventMessages($request_static->error, $request_static->errors, 'errors');
					}
				}
			}
			elseif (isModEnabled('questionnaire') && $action == 'confirm_rm_send_survey' && $confirm == 'yes' && is_array($toselect)) {
				$questionnaire_id = GETPOST('questionnaire_id', 'int');
				$only_new = GETPOST('only_new', 'aZ09');
				$force_date_answer_deadline = GETPOST('force_date_answer_deadline', 'aZ09');
				$date_answer_deadline = dol_mktime(0, 0, 0, GETPOST('date_answer_deadlinemonth', 'int'), GETPOST('date_answer_deadlineday', 'int'), GETPOST('date_answer_deadlineyear', 'int'));
				$subject = GETPOST('subject', 'alpha');
				$message = GETPOST('message', 'alpha');

				$request_static = new RequestManager($db);
				$request_static->loadRequestStatus();

				foreach ($toselect as $r_id) {
					$request_static->fetch($r_id);
					if (empty(RequestManager::$status_list[$request_static->statut]->fields['survey'])) continue;
					$result = $request_static->sendSurvey($user, $questionnaire_id, $date_answer_deadline, $subject, $message, !empty($force_date_answer_deadline), !empty($only_new));
					if ($result < 0 || !empty($request_static->errors)) {
						setEventMessages($request_static->error, $request_static->errors, 'errors');
					}
				}
			}
		}
	}
}



/*
 * View
 */

$now=dol_now();

$form = new Form($db);
$formother = new FormOther($db);
$formdictionary = new FormDictionary($db);
$formrequestmanager = new FormRequestManager($db);
$usergroup_static = new UserGroup($db);

$title = $langs->trans('RequestManagerListOfRequests');
if ($planning) {
    $title = $langs->trans('RequestManagerPlanningListOfRequests');
    if ($my_list && in_array($user->id, $search_in_charge)) $title .= ' (' . $langs->trans('RequestManagerPlanningInCharge') . ')';
} else {
    if ($my_list) $title .= ' (' . $langs->trans('RequestManagerMyRequest') . ')';
    if ($not_assigned) $title .= ' (' . $langs->trans('RequestManagerNotAssigned') . ')';
}
if ($socid > 0) {
    $langs->load("companies");
}

$help_url='EN:RequestManager_En|FR:RequestManager_Fr|ES:RequestManager_Es';
llxHeader('', ($socid > 0 ? $langs->trans("ThirdParty") . ' - ' : '') . $title, $help_url, '', 0, 0, $planning ? array('/requestmanager/js/opendsi.js') : array());

if ($socid > 0) {
	/*
	 * Affichage onglets
	 */
	$societe = new Societe($db);
	$societe->fetch($socid);

	require_once DOL_DOCUMENT_ROOT . '/core/lib/company.lib.php';
	$head = societe_prepare_head($societe);

	$active_tab = 'rm_request_list';
	if ($planning) $active_tab = 'rm_request_planning_list';
	print dol_get_fiche_head($head, $active_tab, $langs->trans("ThirdParty"), -1, 'company');

	$linkback = '<a href="' . DOL_URL_ROOT . '/societe/list.php?restore_lastsearch_values=1">' . $langs->trans("BackToList") . '</a>';

	dol_banner_tab($societe, 'socid', $linkback, ($user->societe_id ? 0 : 1), 'rowid', 'nom');

	$cssclass = 'titlefield';

	print '<div class="fichecenter">';

	print '<div class="underbanner clearboth"></div>';
	print '<table class="border centpercent">';

	if (!empty($conf->global->SOCIETE_USEPREFIX))  // Old not used prefix field
	{
		print '<tr><td class="' . $cssclass . '">' . $langs->trans('Prefix') . '</td><td colspan="3">' . $societe->prefix_comm . '</td></tr>';
	}

	if ($societe->client) {
		print '<tr><td class="' . $cssclass . '">';
		print $langs->trans('CustomerCode') . '</td><td colspan="3">';
		print $societe->code_client;
		if ($societe->check_codeclient() <> 0) print ' <font class="error">(' . $langs->trans("WrongCustomerCode") . ')</font>';
		print '</td></tr>';
	}

	if ($societe->fournisseur) {
		print '<tr><td class="' . $cssclass . '">';
		print $langs->trans('SupplierCode') . '</td><td colspan="3">';
		print $societe->code_fournisseur;
		if ($societe->check_codefournisseur() <> 0) print ' <font class="error">(' . $langs->trans("WrongSupplierCode") . ')</font>';
		print '</td></tr>';
	}

	print "</table>";

	print '</div>';
} elseif ($contact_id > 0) {
	/*
	 * Affichage onglets
	 */
	$contact = new Contact($db);
	$contact->fetch($contact_id);

	require_once DOL_DOCUMENT_ROOT . '/core/lib/contact.lib.php';
	$head = contact_prepare_head($contact);

	$active_tab = 'rm_request_list';
	if ($planning) $active_tab = 'rm_request_planning_list';
	print dol_get_fiche_head($head, $active_tab, $title, -1, 'contact');

	$linkback = '<a href="'.DOL_URL_ROOT.'/contact/list.php?restore_lastsearch_values=1">'.$langs->trans("BackToList").'</a>';

	dol_banner_tab($contact, 'contact_id', $linkback, 1, 'rowid', 'ref', '');

	print '<div class="fichecenter">';

	print '<div class="underbanner clearboth"></div>';
	print '<table class="border centpercent">';

	print "</table>";

	print '</div>';
}

if (empty($planning) || count($request_types_planned) > 0) {
//    $formconfirm = '';
//
//    // Confirm box for the planning
//    if ($planning && ($massaction == 'rm_planning' || $action == 'to_plan') && $user->rights->requestmanager->planning->manage) {
//        $users_in_charge = array();
//        $request_list = $massaction == 'rm_planning' ? $toselect : array($request_id);
//        $request_list = array_flip(array_flip($request_list));
//        if ($nb_request_selected = count($request_list)) {
//            $sql = 'SELECT ugu.fk_user, COUNT(DISTINCT rm.rowid) AS nb_request_in_charge FROM ' . MAIN_DB_PREFIX . 'societe_rm_usergroup_in_charge AS srmugic' .
//                ' LEFT JOIN ' . MAIN_DB_PREFIX . 'usergroup_user as ugu ON ugu.fk_usergroup = srmugic.fk_usergroup AND ' . (isModEnabled('multicompany') && $conf->entity == 1 && $user->admin && !$user->entity ? 'ugu.entity IS NOT NULL' : 'ugu.entity IN (0,' . $conf->entity . ')') .
//                ' LEFT JOIN ' . MAIN_DB_PREFIX . 'requestmanager as rm ON srmugic.fk_soc = rm.fk_soc AND srmugic.fk_c_request_type = rm.fk_type' .
//                ' WHERE rm.rowid IN (' . implode(',', $request_list) . ')' .
//                ' GROUP BY ugu.fk_user';
//
//            $resql = $db->query($sql);
//            if ($resql) {
//                while ($obj = $db->fetch_object($resql)) {
//                    if ($nb_request_selected == $obj->nb_request_in_charge) {
//                        $users_in_charge[] = $obj->fk_user;
//                    }
//                }
//            }
//
//            $date_operation = dol_mktime(GETPOST('operate_datehour', 'int'), GETPOST('operate_datemin', 'int'), 0, GETPOST('operate_datemonth', 'int'), GETPOST('operate_dateday', 'int'), GETPOST('operate_dateyear', 'int'));
//            $date_deadline = dol_mktime(GETPOST('deadline_datehour', 'int'), GETPOST('deadline_datemin', 'int'), 0, GETPOST('deadline_datemonth', 'int'), GETPOST('deadline_dateday', 'int'), GETPOST('deadline_dateyear', 'int'));
//            $assigned_user_ids = isset($_POST['operate_datehour']) ? GETPOST('assigned_user_ids', 'array') : $users_in_charge;
//
//            $formquestion = array(
//                array('type' => 'date', 'name' => 'operate_date', 'label' => '<span class="fieldrequired">' . $langs->trans("RequestManagerOperation") . '</span>', 'hour' => 1, 'minute' => 1, 'value' => $date_operation > 0 ? $date_operation : -1),
//                array('type' => 'date', 'name' => 'deadline_date', 'label' => $langs->trans("RequestManagerDeadline"), 'hour' => 1, 'minute' => 1, 'value' => $date_deadline > 0 ? $date_deadline : -1),
//                array('type' => 'other', 'name' => 'assigned_user_ids', 'label' => '<span class="fieldrequired">' . $langs->trans("RequestManagerAssignedUsers") . '</span>', 'value' => $formrequestmanager->multiselect_dolusers(array(), 'assigned_user_ids', null, 0, '', '', 0, 0, 0, '', 0, '', 'minwidth300', 1, 0)),
//                array('type' => 'hidden', 'name' => 'old_massaction', 'value' => $massaction),
//                array('type' => 'hidden', 'name' => 'old_action', 'value' => $action),
//            );
//
//            // For ExtendedIntervention module
//            //--------------------------------------------------
//            if (isModEnabled('extendedintervention')) {
//                $rm_force_create_intervention = !empty(GETPOST('rm_force_create_intervention', 'alpha')) ? 1 : 0;
//                $formquestion[] = array('type' => 'checkbox', 'name' => 'rm_force_create_intervention', 'label' => $langs->trans("RequestManagerForceCreateIntervention"), 'value' => $rm_force_create_intervention);
//            }
//
//            foreach ($request_list as $r_id) {
//                $formquestion[] = array('type' => 'hidden', 'name' => 'request_list[]', 'value' => $r_id);
//            }
//
//            $params_array = array_merge($_GET, $_POST);
//            $exclude_keys = array('action', 'massaction', 'operate_date', 'operate_datehour', 'operate_datemin', 'operate_datemonth', 'operate_dateday', 'operate_dateyear',
//                'deadline_date', 'deadline_datehour', 'deadline_datemin', 'deadline_datemonth', 'deadline_dateday', 'deadline_dateyear', 'assigned_user_ids', 'old_massaction', 'old_action', 'request_list');
//            foreach ($params_array as $k => $v) {
//                if (in_array($k, $exclude_keys)) continue;
//                if (is_array($v)) {
//                    foreach ($v as $va) {
//                        $formquestion[] = array('type' => 'hidden', 'name' => $k . '[]', 'value' => $va);
//                    }
//                } else {
//                    $formquestion[] = array('type' => 'hidden', 'name' => $k, 'value' => $v);
//                }
//            }
//
//            $params2 = '';
//            if ($planning) $params2 .= '&planning=' . urlencode($planning);
//            if ($my_list) $params2 .= '&my_list=' . urlencode($my_list);
//            if (empty($planning) && $not_assigned) $params2 .= '&not_assigned=' . urlencode($not_assigned);
//            if ($socid > 0) $params2 .= '&socid=' . urlencode($socid);
//            $params2 = !empty($params2) ? '?' . substr($params2, 1) : '';
//
//            $formconfirm = $formrequestmanager->formconfirm($_SERVER["PHP_SELF"] . $params2, $langs->trans('RequestManagerPlanningRequest'), $langs->trans('RequestManagerConfirmPlanningRequest'), 'confirm_planning', $formquestion, 'yes', 1, 300, 800, 1);
//
//            $users_in_charge = json_encode($users_in_charge);
//            $assigned_user_ids = json_encode($assigned_user_ids);
//            $formconfirm .= <<<SCRIPT
//    <script type="text/javascript">
//        $(document).ready(function () {
//            move_top_select_options('assigned_user_ids', $users_in_charge);
//            set_select_options('assigned_user_ids', $assigned_user_ids);
//        });
//    </script>
//SCRIPT;
//        }
//    }
//
//    // Hook
//    $parameters = array();
//    $reshook = $hookmanager->executeHooks('formConfirm', $parameters, $object, $action); // Note that $action and $object may have been modified by hook
//    if (empty($reshook)) $formconfirm.=$hookmanager->resPrint;
//    elseif ($reshook > 0) $formconfirm=$hookmanager->resPrint;
//
//   	// Print form confirm
//   	print $formconfirm;

	$sql = "";
	if ($search_ref) {
		$sql .= "WITH RECURSIVE requestmanager_tree(parent_id, child_id) AS (";
		$sql .= "  SELECT fk_parent AS parent_id, rowid AS child_id FROM " . MAIN_DB_PREFIX . "requestmanager";
		$sql .= "  UNION";
		$sql .= "  SELECT rm.fk_parent AS parent_id, rm.rowid AS child_id FROM " . MAIN_DB_PREFIX . "requestmanager AS rm";
		$sql .= "  JOIN requestmanager_tree AS rmt ON rmt.parent_id = rm.rowid";
		$sql .= "), parent_search_ref(request_id, parent_ref) AS (";
		$sql .= "  SELECT rmt.child_id AS request_id, rm.ref AS parent_ref FROM requestmanager_tree AS rmt";
		$sql .= "  LEFT JOIN " . MAIN_DB_PREFIX . "requestmanager AS rm ON rm.rowid = rmt.parent_id";
		$sql .= " WHERE " . natural_search('rm.ref', $search_ref, 0, 1);
		$sql .= ")";
	}
	// Add fields from hooks
	$parameters = array();
	$reshook = $hookmanager->executeHooks('printFieldListWith', $parameters);    // Note that $action and $object may have been modified by hook
	$sql .= $hookmanager->resPrint;
    $sql .= 'SELECT';
    if ($sall) $sql .= ' DISTINCT';
    $sql .= ' rm.rowid, rm.fk_parent, rm.ref, rm.ref_ext,';
    $sql .= ' rm.fk_soc, s.nom as soc_name_origin, s.name_alias as soc_name_alias_origin, s.client as soc_client_origin, s.fournisseur as soc_fournisseur_origin, s.code_client as soc_code_client_origin, s.code_fournisseur as soc_code_fournisseur_origin,';
	$sql .= ' GROUP_CONCAT(DISTINCT ec.fk_socpeople SEPARATOR \',\') as requester_contacts,';
    $sql .= ' rm.label, rm.description,';
    $sql .= ' rm.fk_type, crmrt.label as type_label,';
    $sql .= ' rm.fk_category, crmc.label as category_label,';
    $sql .= ' rm.fk_source, crms.label as source_label,';
    $sql .= ' rm.fk_urgency, crmu.label as urgency_label,';
    $sql .= ' rm.fk_impact, crmi.label as impact_label,';
    $sql .= ' rm.fk_priority, crmp.label as priority_label,';
    $sql .= ' rm.notify_requester_by_email, rm.notify_watcher_by_email, rm.notify_assigned_by_email,';
    if ($planning) $sql .= ' GROUP_CONCAT(DISTINCT ugu.fk_user SEPARATOR \',\') as users_in_charge,';
    $sql .= ' GROUP_CONCAT(DISTINCT rmau.fk_user SEPARATOR \',\') as assigned_users,';
    $sql .= ' GROUP_CONCAT(DISTINCT rmaug.fk_usergroup SEPARATOR \',\') as assigned_usergroups,';
    $sql .= ' rm.estimated_duration, rm.effective_duration, rm.total_effective_duration, rm.reported_progress, rm.effective_cost, rm.date_operation, rm.date_deadline, rm.date_resolved, rm.date_closed,';
    $sql .= ' rm.fk_user_resolved, ur.firstname as userresolvedfirstname, ur.lastname as userresolvedlastname, ur.email as userresolvedemail,';
    $sql .= ' rm.fk_user_closed, uc.firstname as userclosedfirstname, uc.lastname as userclosedlastname, uc.email as userclosedemail,';
    $sql .= ' rm.fk_status,';
    $sql .= ' rm.datec, rm.tms,';
    $sql .= ' rm.fk_user_author, ua.firstname as userauthorfirstname, ua.lastname as userauthorlastname, ua.email as userauthoremail,';
    $sql .= ' rm.fk_user_modif, um.firstname as usermodiffirstname, um.lastname as usermodiflastname, um.email as usermodifemail,';
    $sql .= ' crmrr.label AS reason_resolution, rm.reason_resolution_details';
	// Add fields from extrafields
	if (version_compare(DOL_VERSION, "13.0.0") >= 0) {
		if (!empty($extrafields->attributes[$object->table_element]['label'])) {
			foreach ($extrafields->attributes[$object->table_element]['label'] as $key => $val) {
				$sql .= ($extrafields->attributes[$object->table_element]['type'][$key] != 'separate' ? ", ef.".$key.' as options_'.$key : '');
			}
		}
	} else {
		foreach ($extrafields->attribute_label as $key => $val) $sql .= ($extrafields->attribute_type[$key] != 'separate' ? ", ef." . $key . ' as options_' . $key : '');
	}
    // Add fields from hooks
    $parameters = array();
    $reshook = $hookmanager->executeHooks('printFieldListSelect', $parameters);    // Note that $action and $object may have been modified by hook
    $sql .= $hookmanager->resPrint;
    $sql .= ' FROM ' . MAIN_DB_PREFIX . 'requestmanager as rm';
    $sql .= " LEFT JOIN " . MAIN_DB_PREFIX . "c_requestmanager_request_type as crmrt on (crmrt.rowid = rm.fk_type)";
    $sql .= " LEFT JOIN " . MAIN_DB_PREFIX . "c_requestmanager_category as crmc on (crmc.rowid = rm.fk_category)";
    $sql .= " LEFT JOIN " . MAIN_DB_PREFIX . "c_requestmanager_source as crms on (crms.rowid = rm.fk_source)";
    $sql .= " LEFT JOIN " . MAIN_DB_PREFIX . "c_requestmanager_urgency as crmu on (crmu.rowid = rm.fk_urgency)";
    $sql .= " LEFT JOIN " . MAIN_DB_PREFIX . "c_requestmanager_impact as crmi on (crmi.rowid = rm.fk_impact)";
    $sql .= " LEFT JOIN " . MAIN_DB_PREFIX . "c_requestmanager_priority as crmp on (crmp.rowid = rm.fk_priority)";
    $sql .= " LEFT JOIN " . MAIN_DB_PREFIX . "c_requestmanager_status as crmst on (crmst.rowid = rm.fk_status)";
    $sql .= " LEFT JOIN " . MAIN_DB_PREFIX . "c_requestmanager_reason_resolution as crmrr on (crmrr.rowid = rm.fk_reason_resolution)";
    $sql .= " LEFT JOIN " . MAIN_DB_PREFIX . "societe as s on (s.rowid = rm.fk_soc)";
	$sql .= ' LEFT JOIN ' . MAIN_DB_PREFIX . 'element_contact as ec ON (ec.fk_c_type_contact = 163018 AND ec.element_id = rm.rowid)';
	if (version_compare(DOL_VERSION, "13.0.0") >= 0) {
		if (isset($extrafields->attributes[$object->table_element]['label']) && is_array($extrafields->attributes[$object->table_element]['label']) && count($extrafields->attributes[$object->table_element]['label'])) {
			$sql .= " LEFT JOIN " . MAIN_DB_PREFIX . $object->table_element . "_extrafields as ef on (rm.rowid = ef.fk_object)";
		}
	} else {
		if (is_array($extrafields->attribute_label) && count($extrafields->attribute_label)) $sql .= " LEFT JOIN " . MAIN_DB_PREFIX . "requestmanager_extrafields as ef on (rm.rowid = ef.fk_object)";
	}
    $sql .= ' LEFT JOIN ' . MAIN_DB_PREFIX . 'user as ur ON ur.rowid = rm.fk_user_resolved';
    $sql .= ' LEFT JOIN ' . MAIN_DB_PREFIX . 'user as uc ON uc.rowid = rm.fk_user_closed';
    $sql .= ' LEFT JOIN ' . MAIN_DB_PREFIX . 'user as ua ON ua.rowid = rm.fk_user_author';
    $sql .= ' LEFT JOIN ' . MAIN_DB_PREFIX . 'user as um ON um.rowid = rm.fk_user_modif';
    if ($planning) {
        $sql .= ' LEFT JOIN ' . MAIN_DB_PREFIX . 'societe_rm_usergroup_in_charge as srmugic ON srmugic.fk_soc = rm.fk_soc AND srmugic.fk_c_request_type = rm.fk_type';
        $sql .= ' LEFT JOIN ' . MAIN_DB_PREFIX . 'usergroup_user as ugu ON ugu.fk_usergroup = srmugic.fk_usergroup AND ' . (isModEnabled('multicompany') && $conf->entity == 1 && $user->admin && !$user->entity ? 'ugu.entity IS NOT NULL' : 'ugu.entity IN (0,' . $conf->entity . ')');
    }
    $sql .= ' LEFT JOIN ' . MAIN_DB_PREFIX . 'requestmanager_assigned_user as rmau ON rmau.fk_requestmanager = rm.rowid';
    $sql .= ' LEFT JOIN ' . MAIN_DB_PREFIX . 'requestmanager_assigned_usergroup as rmaug ON rmaug.fk_requestmanager = rm.rowid';
	if ($search_ref) {
		$sql .= ' LEFT JOIN parent_search_ref as psr ON psr.request_id = rm.rowid';
	}
	if (count($search_tags)) $sql .= ' LEFT JOIN ' . MAIN_DB_PREFIX . "categorie_requestmanager as cp ON rm.rowid = cp.fk_requestmanager"; // We'll need this table joined to the select in order to filter by categ
    if ($search_assigned_user || $search_assigned_usergroup || $my_list || (empty($planning) && $not_assigned)) {
        $sql .= ' INNER JOIN (';
        $sql .= '   SELECT rm.rowid';
        $sql .= '   FROM ' . MAIN_DB_PREFIX . 'requestmanager as rm';
        $sql .= '   LEFT JOIN ' . MAIN_DB_PREFIX . 'requestmanager_assigned_user as rmau ON rmau.fk_requestmanager = rm.rowid';
        $sql .= '   LEFT JOIN ' . MAIN_DB_PREFIX . 'requestmanager_assigned_usergroup as rmaug ON rmaug.fk_requestmanager = rm.rowid';
        $sql .= '   LEFT JOIN ' . MAIN_DB_PREFIX . 'user as uas ON uas.rowid = rmau.fk_user';
        $sql .= '   LEFT JOIN ' . MAIN_DB_PREFIX . 'usergroup as uga ON uga.rowid = rmaug.fk_usergroup';
        $sql .= '   WHERE rm.entity IN (' . getEntity('requestmanager') . ')';
        if ($search_assigned_user) $sql .= natural_search(array('uas.firstname', 'uas.lastname'), $search_assigned_user);
        if ($search_assigned_usergroup) $sql .= natural_search('uga.nom', $search_assigned_usergroup);
        if (empty($planning)) {
            if ($my_list) {
                $groupslist = $usergroup_static->listGroupsForUser($user->id);
                $sql .= ' AND (rmau.fk_user = ' . $user->id;
                if (!empty($groupslist)) {
                    $sql .= ' OR rmaug.fk_usergroup IN (' . implode(',', array_keys($groupslist)) . ')';
                }
                $sql .= ')';
            }
            if ($not_assigned) $sql .= ' AND (rmau.fk_user IS NULL OR rmau.fk_user = 0) AND (rmaug.fk_usergroup IS NULL OR rmaug.fk_usergroup = 0)';
        }
        $sql .= '   GROUP BY rm.rowid';
        $sql .= ' ) as assigned ON assigned.rowid = rm.rowid';
    }
    if ($planning && count($search_in_charge) > 0) {
        $sql .= ' INNER JOIN (';
        $sql .= '   SELECT srmugic.fk_soc, srmugic.fk_c_request_type ';
        $sql .= '   FROM ' . MAIN_DB_PREFIX . 'societe_rm_usergroup_in_charge as srmugic';
        $sql .= '   LEFT JOIN ' . MAIN_DB_PREFIX . 'usergroup_user as ugu ON ugu.fk_usergroup = srmugic.fk_usergroup AND ' . (isModEnabled('multicompany') && $conf->entity == 1 && $user->admin && !$user->entity ? 'ugu.entity IS NOT NULL' : 'ugu.entity IN (0,' . $conf->entity . ')');
        $sql .= '   WHERE ugu.fk_user IN (' . implode(',', $search_in_charge) . ')';
        $sql .= '   GROUP BY srmugic.fk_soc, srmugic.fk_c_request_type';
        $sql .= ' ) as in_charge ON in_charge.fk_soc = rm.fk_soc AND in_charge.fk_c_request_type = rm.fk_type';
    }
	if ($contact_id > 0 || !empty($search_requester_contacts)) {
		$sql .= ' LEFT JOIN (';
		$sql .= '   SELECT ec.element_id';
		$sql .= '   FROM ' . MAIN_DB_PREFIX . 'element_contact as ec';
		if (!empty($search_requester_contacts)) $sql .= "   LEFT JOIN " . MAIN_DB_PREFIX . "socpeople as sp on sp.rowid = ec.fk_socpeople";
		$sql .= '   WHERE ec.fk_c_type_contact = 163018'; // 163018 = Contact Type REQUESTER (contacts origin)
		if ($contact_id > 0) $sql .= '   AND ec.fk_socpeople = ' . $contact_id;
		if (!empty($search_requester_contacts)) $sql .= natural_search(array('sp.firstname', 'sp.lastname'), $search_requester_contacts);
		$sql .= '   GROUP BY ec.element_id';
		$sql .= ' ) as col ON col.element_id = rm.rowid';
	}
    // Add From from hooks
    $parameters = array();
    $reshook = $hookmanager->executeHooks('printFieldListFrom', $parameters);    // Note that $action and $object may have been modified by hook
    $sql .= $hookmanager->resPrint;
    $sql .= ' WHERE rm.entity IN (' . getEntity('requestmanager') . ')';
    if ($planning) {
        $status_filter = array();
        foreach ($request_types_planned as $request_type_id) {
            if ($conf->global->{'REQUESTMANAGER_PLANNING_REQUEST_STATUS_TO_PLAN_' . $request_type_id} > 0) {
                $status_filter[] = $conf->global->{'REQUESTMANAGER_PLANNING_REQUEST_STATUS_TO_PLAN_' . $request_type_id};
            }
        }
        $sql .= " AND rm.fk_status IN (" . implode(',', $status_filter) . ")";
    }
    if ($search_ref) $sql .= " AND (" . natural_search('rm.ref', $search_ref, 0, 1) . " OR psr.request_id IS NOT NULL)";
    if ($search_ref_ext) $sql .= natural_search('rm.ref_ext', $search_ref_ext);
    if ($search_type) $sql .= natural_search('crmrt.label', $search_type);
    if ($search_category) $sql .= natural_search('crmc.label', $search_category);
    if ($search_label) $sql .= natural_search('rm.label', $search_label);
    if ($search_thridparty_origin) $sql .= natural_search(array('s.nom', 's.name_alias'), $search_thridparty_origin);
	if ($socid > 0) $sql .= ' AND rm.fk_soc = ' . $socid;
	if ($contact_id > 0 || !empty($search_requester_contacts)) $sql .= ' AND col.element_id IS NOT NULL';
    if ($search_source) $sql .= natural_search('crms.label', $search_source);
    if ($search_urgency) $sql .= natural_search('crmu.label', $search_urgency);
    if ($search_impact) $sql .= natural_search('crmi.label', $search_impact);
    if ($search_priority) $sql .= natural_search('crmp.label', $search_priority);
//    if ($search_estimated_duration) $sql .= natural_search('rm.estimated_duration', $search_estimated_duration, 1);
//    if ($search_effective_duration) $sql .= natural_search('rm.effective_duration', $search_effective_duration, 1);
//    if ($search_reported_progress) $sql .= natural_search('rm.reported_progress', $search_reported_progress, 1);
    if ($search_date_operation) $sql .= natural_search('rm.date_operation', $search_date_operation, 1);
    if ($search_date_deadline) $sql .= natural_search('rm.date_deadline', $search_date_deadline, 1);
    if ($search_notify_requester_by_email >= 0) $sql .= ' AND rm.notify_requester_by_email = ' . $search_notify_requester_by_email;
    if ($search_notify_watcher_by_email >= 0) $sql .= ' AND rm.notify_watcher_by_email = ' . $search_notify_watcher_by_email;
    if ($search_notify_assigned_by_email >= 0) $sql .= ' AND rm.notify_assigned_by_email = ' . $search_notify_assigned_by_email;
    if ($search_description) $sql .= natural_search('rm.description', $search_description);
    if (count($search_tags)) $sql .= " AND cp.fk_categorie IN (" . implode(',', $search_tags) . ")";
    if ($search_reason_resolution > 0) $sql .= " AND rm.fk_reason_resolution = " . $search_reason_resolution;
    if ($search_reason_resolution_details) $sql .= natural_search('rm.reason_resolution_details', $search_reason_resolution_details);
    if ($search_date_resolved) $sql .= natural_search('rm.date_resolved', $search_date_resolved, 1);
    if ($search_date_cloture) $sql .= natural_search('rm.date_closed', $search_date_cloture, 1);
    if ($search_user_resolved) $sql .= natural_search(array('ur.firstname', 'ur.lastname'), $search_user_resolved);
    if ($search_user_cloture) $sql .= natural_search(array('uc.firstname', 'uc.lastname'), $search_user_cloture);
    if ($search_date_creation) $sql .= natural_search('rm.datec', $search_date_creation, 1);
    if ($search_date_modification) $sql .= natural_search('rm.tms', $search_date_modification, 1);
    if ($search_user_author) $sql .= natural_search(array('ua.firstname', 'ua.lastname'), $search_user_author);
    if ($search_user_modification) $sql .= natural_search(array('um.firstname', 'um.lastname'), $search_user_modification);
    if ($search_user_modification) $sql .= natural_search(array('um.firstname', 'um.lastname'), $search_user_modification);
    if ($search_dont_show_children_request) $sql .= ' AND rm.fk_parent IS NULL';
    if (count($search_status_det)) $sql .= natural_search(array('rm.fk_status'), implode(',', $search_status_det), 2);
    if ($status_type >= 0) $sql .= ' AND crmst.type = ' . $status_type;
    elseif ($status_type == -2) $sql .= ' AND crmst.type IN (' . RequestManager::STATUS_TYPE_INITIAL . ', ' . RequestManager::STATUS_TYPE_IN_PROGRESS . ')';
    if ($sall) {
        $sql .= natural_search(array_keys($fieldstosearchall), $sall);
    }
	// Add where from extra fields
	include DOL_DOCUMENT_ROOT.'/core/tpl/extrafields_list_search_sql.tpl.php';
    // Add where from hooks
    $parameters = array();
    $reshook = $hookmanager->executeHooks('printFieldListWhere', $parameters);    // Note that $action and $object may have been modified by hook
    $sql .= $hookmanager->resPrint;

    $sql .= ' GROUP BY rm.rowid';
	if ($sortfield == 'rm.ref' && $search_ref) {
		$sql .= ", psr.parent_ref";
		$sql .= " ORDER BY IFNULL(psr.parent_ref, rm.ref) $sortorder, psr.parent_ref IS NULL $sortorder, rm.ref $sortorder";
	} else {
		$sql .= $db->order($sortfield, $sortorder);
	}
	// Add where from hooks
	$parameters = array();
	$reshook = $hookmanager->executeHooks('printFieldListGroupBy', $parameters);    // Note that $action and $object may have been modified by hook
	$sql .= $hookmanager->resPrint;

    // Count total nb of records
    $nbtotalofrecords = '';
    if (empty($conf->global->MAIN_DISABLE_FULL_SCANLIST)) {
        $result = $db->query($sql);
        $nbtotalofrecords = $db->num_rows($result);
    }

    $sql .= $db->plimit($limit + 1, $offset);

    $resql = $db->query($sql);
    if ($resql) {
        $objectstatic = new RequestManager($db);
        $userstatic = new User($db);
        $societestatic_origin = new Societe($db);
        $societestatic = new Societe($db);
        $societestatic_benefactor = new Societe($db);
        $societestatic_watcher = new Societe($db);

        $num = $db->num_rows($resql);

        $arrayofselected = is_array($toselect) ? $toselect : array();

        $param = '';
        if (!empty($contextpage) && $contextpage != $_SERVER["PHP_SELF"]) $param .= '&contextpage=' . urlencode($contextpage);
        if ($limit > 0 && $limit != $conf->liste_limit) $param .= '&limit=' . urlencode($limit);
        if ($sall) $param .= '&sall=' . urlencode($sall);
		if ($socid) $param .= '&socid=' . urlencode($socid);
		if ($contact_id) $param .= '&contact_id=' . urlencode($contact_id);
        if ($search_ref) $param .= '&search_ref=' . urlencode($search_ref);
        if ($search_ref_ext) $param .= '&search_ref_ext=' . urlencode($search_ref_ext);
        if ($search_type) $param .= '&search_type=' . urlencode($search_type);
        if ($search_category) $param .= '&search_category=' . urlencode($search_category);
        if ($search_label) $param .= '&search_label=' . urlencode($search_label);
        if ($search_thridparty_origin) $param .= '&search_thridparty_origin=' . urlencode($search_thridparty_origin);
		if ($search_requester_contacts) $param .= '&search_requester_contacts=' . urlencode($search_requester_contacts);
        if ($search_source) $param .= '&search_source=' . urlencode($search_source);
        if ($search_urgency) $param .= '&search_urgency=' . urlencode($search_urgency);
        if ($search_impact) $param .= '&search_impact=' . urlencode($search_impact);
        if ($search_priority) $param .= '&search_priority=' . urlencode($search_priority);
//        if ($search_estimated_duration) $param .= '&search_estimated_duration=' . urlencode($search_estimated_duration);
//        if ($search_effective_duration) $param .= '&search_effective_duration=' . urlencode($search_effective_duration);
//        if ($search_reported_progress) $param .= '&search_reported_progress=' . urlencode($search_reported_progress);
        if ($search_date_operation) $param .= '&search_date_operation=' . urlencode($search_date_operation);
        if ($search_date_deadline) $param .= '&search_date_deadline=' . urlencode($search_date_deadline);
        if ($search_notify_requester_by_email >= 0) $param .= '&search_notify_requester_by_email=' . urlencode($search_notify_requester_by_email);
        if ($search_notify_watcher_by_email >= 0) $param .= '&search_notify_watcher_by_email=' . urlencode($search_notify_watcher_by_email);
        if ($search_assigned_user) $param .= '&search_assigned_user=' . urlencode($search_assigned_user);
        if ($search_assigned_usergroup) $param .= '&search_assigned_usergroup=' . urlencode($search_assigned_usergroup);
        if ($search_notify_assigned_by_email >= 0) $param .= '&search_notify_assigned_by_email=' . urlencode($search_notify_assigned_by_email);
        if ($search_description) $param .= '&search_description=' . urlencode($search_description);
        if (count($search_tags)) $param .= '&'.http_build_query(array('search_tags'=>$search_tags));
        if ($search_reason_resolution > 0) $param .= '&search_reason_resolution=' . urlencode($search_reason_resolution);
        if ($search_reason_resolution_details) $param .= '&search_reason_resolution_details=' . urlencode($search_reason_resolution_details);
        if ($search_date_resolved) $param .= '&search_date_resolved=' . urlencode($search_date_resolved);
        if ($search_date_cloture) $param .= '&search_date_cloture=' . urlencode($search_date_cloture);
        if ($search_user_resolved) $param .= '&search_user_resolved=' . urlencode($search_user_resolved);
        if ($search_user_cloture) $param .= '&search_user_cloture=' . urlencode($search_user_cloture);
        if ($search_date_creation) $param .= '&search_date_creation=' . urlencode($search_date_creation);
        if ($search_date_modification) $param .= '&search_date_modification=' . urlencode($search_date_modification);
        if ($search_user_author) $param .= '&search_user_author=' . urlencode($search_user_author);
        if ($search_user_modification) $param .= '&search_user_modification=' . urlencode($search_user_modification);
        if (count($search_status_det)) $param .= '&'.http_build_query(array('search_status_det'=>$search_status_det));
        if ($search_dont_show_children_request) $param .= '&search_dont_show_children_request=' . urlencode($search_dont_show_children_request);
        if (count($search_in_charge)) $param .= '&'.http_build_query(array('search_in_charge'=>$search_in_charge));
        if ($planning) $param .= '&planning=' . urlencode($planning);
        if ($my_list) $param .= '&my_list=' . urlencode($my_list);
        if (empty($planning) && $not_assigned) $param .= '&not_assigned=' . urlencode($not_assigned);
        if ($status_type !== '' && $status_type != -1) $param .= '&status_type=' . urlencode($status_type);
        if ($optioncss != '') $param .= '&optioncss=' . urlencode($optioncss);

		// Add $param from extra fields
		include DOL_DOCUMENT_ROOT.'/core/tpl/extrafields_list_search_param.tpl.php';

        // List of mass actions available
        $arrayofmassactions = array();
		if ($user->rights->requestmanager->creer) {
			$arrayofmassactions['rm_create_request_and_link'] = $langs->trans("RequestManagerCreateRequestAndLink");
			$arrayofmassactions['rm_create_request_and_link_as_children'] = $langs->trans("RequestManagerCreateRequestAndLinkAsChildren");
		}
        if ($planning) {
            if ($user->rights->requestmanager->planning->manage) $arrayofmassactions['rm_planning'] = $langs->trans("RequestManagerPlanning");
        } else {
//			if (isModEnabled('questionnaire')) {
//				$arrayofmassactions['pre_rm_create_survey'] = $langs->trans("RequestManagerCreateSurvey");
//				$arrayofmassactions['pre_rm_send_survey'] = $langs->trans("RequestManagerSendSurvey");
//			}
			if ($user->rights->requestmanager->supprimer) $arrayofmassactions['pre_rm_delete'] = $langs->trans("Delete");
        }
		if (in_array($massaction, array('pre_rm_delete', 'rm_planning', 'pre_rm_send_survey'))) $arrayofmassactions = array();
		$massactionbutton = $form->selectMassAction('', $arrayofmassactions);

        $params2 = '';
        if ($planning) $params2 .= '&planning=' . urlencode($planning);
        if ($my_list) $params2 .= '&my_list=' . urlencode($my_list);
        if (empty($planning) && $not_assigned) $params2 .= '&not_assigned=' . urlencode($not_assigned);
        if ($socid > 0) $params2 .= '&socid=' . urlencode($socid);
		if ($contact_id > 0) $params2 .= '&contact_id=' . urlencode($contact_id);
        $params2 = !empty($params2) ? '?' . substr($params2, 1) : '';

        // Lignes des champs de filtre
        print '<form method="POST" id="searchFormList" action="' . $_SERVER["PHP_SELF"] . $params2 . '">';
        if ($optioncss != '') print '<input type="hidden" name="optioncss" value="' . $optioncss . '">';
        print '<input type="hidden" name="token" value="' . $_SESSION['newtoken'] . '">';
        print '<input type="hidden" name="formfilteraction" id="formfilteraction" value="list">';
        print '<input type="hidden" name="action" value="list">';
        print '<input type="hidden" name="sortfield" value="' . $sortfield . '">';
        print '<input type="hidden" name="sortorder" value="' . $sortorder . '">';
        print '<input type="hidden" name="page" value="' . $page . '">';
        //if ($status_type != '' && $status_type != -1) print '<input type="hidden" name="status_type" value="' . dol_escape_htmltag($status_type) . '">';

        print_barre_liste($title, $page, $_SERVER["PHP_SELF"], $param, $sortfield, $sortorder, $massactionbutton, $num, $nbtotalofrecords, 'requestmanager@requestmanager', 0, '', '', $limit);

		$formconfirm = '';

		// Confirm box for the planning
		if ($planning) {
			// Todo check if always worked after rewrite !!!!!
			if (($massaction == 'rm_planning' || $action == 'to_plan') && $user->rights->requestmanager->planning->manage) {
				$users_in_charge = array();
				$request_list = $massaction == 'rm_planning' ? $toselect : array($request_id);
				$request_list = array_flip(array_flip($request_list));
				if ($nb_request_selected = count($request_list)) {
					$sql = 'SELECT ugu.fk_user, COUNT(DISTINCT rm.rowid) AS nb_request_in_charge FROM ' . MAIN_DB_PREFIX . 'societe_rm_usergroup_in_charge AS srmugic' .
						' LEFT JOIN ' . MAIN_DB_PREFIX . 'usergroup_user as ugu ON ugu.fk_usergroup = srmugic.fk_usergroup AND ' . (isModEnabled('multicompany') && $conf->entity == 1 && $user->admin && !$user->entity ? 'ugu.entity IS NOT NULL' : 'ugu.entity IN (0,' . $conf->entity . ')') .
						' LEFT JOIN ' . MAIN_DB_PREFIX . 'requestmanager as rm ON srmugic.fk_soc = rm.fk_soc AND srmugic.fk_c_request_type = rm.fk_type' .
						' WHERE rm.rowid IN (' . implode(',', $request_list) . ')' .
						' GROUP BY ugu.fk_user';

					$resql = $db->query($sql);
					if ($resql) {
						while ($obj = $db->fetch_object($resql)) {
							if ($nb_request_selected == $obj->nb_request_in_charge) {
								$users_in_charge[] = $obj->fk_user;
							}
						}
					}

					$date_operation = dol_mktime(GETPOST('operate_datehour', 'int'), GETPOST('operate_datemin', 'int'), 0, GETPOST('operate_datemonth', 'int'), GETPOST('operate_dateday', 'int'), GETPOST('operate_dateyear', 'int'));
					$date_deadline = dol_mktime(GETPOST('deadline_datehour', 'int'), GETPOST('deadline_datemin', 'int'), 0, GETPOST('deadline_datemonth', 'int'), GETPOST('deadline_dateday', 'int'), GETPOST('deadline_dateyear', 'int'));
					$assigned_user_ids = isset($_POST['operate_datehour']) ? GETPOST('assigned_user_ids', 'array') : $users_in_charge;

					$formquestion = array(
						array('type' => 'date', 'name' => 'operate_date', 'label' => '<span class="fieldrequired">' . $langs->trans("RequestManagerOperation") . '</span>', 'hour' => 1, 'minute' => 1, 'value' => $date_operation > 0 ? $date_operation : -1),
						array('type' => 'date', 'name' => 'deadline_date', 'label' => $langs->trans("RequestManagerDeadline"), 'hour' => 1, 'minute' => 1, 'value' => $date_deadline > 0 ? $date_deadline : -1),
						array('type' => 'other', 'name' => 'assigned_user_ids', 'label' => '<span class="fieldrequired">' . $langs->trans("RequestManagerAssignedUsers") . '</span>', 'value' => $formrequestmanager->multiselect_dolusers(array(), 'assigned_user_ids', null, 0, '', '', 0, 0, 0, '', 0, '', 'minwidth300', 1, 0)),
						array('type' => 'hidden', 'name' => 'old_massaction', 'value' => $massaction),
						array('type' => 'hidden', 'name' => 'old_action', 'value' => $action),
					);

					// For ExtendedIntervention module
					//--------------------------------------------------
					if (isModEnabled('extendedintervention')) {
						$rm_force_create_intervention = !empty(GETPOST('rm_force_create_intervention', 'alpha')) ? 1 : 0;
						$formquestion[] = array('type' => 'checkbox', 'name' => 'rm_force_create_intervention', 'label' => $langs->trans("RequestManagerForceCreateIntervention"), 'value' => $rm_force_create_intervention);
					}

					foreach ($request_list as $r_id) {
						$formquestion[] = array('type' => 'hidden', 'name' => 'request_list[]', 'value' => $r_id);
					}

					$formconfirm = $formrequestmanager->formconfirm($_SERVER["PHP_SELF"] . $params2, $langs->trans('RequestManagerPlanningRequest'), $langs->trans('RequestManagerConfirmPlanningRequest'), 'confirm_planning', $formquestion, '', 0, 200, 500, 1);

					$users_in_charge = json_encode($users_in_charge);
					$assigned_user_ids = json_encode($assigned_user_ids);
					$formconfirm .= <<<SCRIPT
    <script type="text/javascript">
        $(document).ready(function () {
            move_top_select_options('assigned_user_ids', $users_in_charge);
            set_select_options('assigned_user_ids', $assigned_user_ids);
        });
    </script>
SCRIPT;
				}
			}
		}
		else {
			// Confirm create survey
			if ($massaction == 'pre_rm_create_survey' && isModEnabled('questionnaire')) {
				$questionnaire_id = GETPOST('questionnaire_id', 'int');
				$date_answer_deadline = dol_mktime(0, 0, 0, GETPOST('date_answer_deadlinemonth', 'int'), GETPOST('date_answer_deadlineday', 'int'), GETPOST('date_answer_deadlineyear', 'int'));

				$nb_selected = count($toselect);
//				$request_static = new RequestManager($db);
//				$questionnaires = $request->getRequestQuestionnaire();
//				$questionnaire = null;
//				if (is_array($questionnaires) && count($questionnaires) == 1) {
//					$questionnaire = array_values($questionnaires)[0];
//				}
				if ($date_answer_deadline === '') $date_answer_deadline = dol_now() + (/*is_object($questionnaire) && $questionnaire->answer_deadline > 0 ? $questionnaire->answer_deadline : */
					$conf->global->QUESTIONNAIRE_DEFAULT_ANSWER_DEADLINE) * 24 * 60 * 60;

				$questionnaire_arr = array();
				if (is_array($questionnaires)) {
					foreach ($questionnaires as $questionnaire) {
						if ($questionnaire_id == '') $questionnaire_id = $questionnaire->id;
						$questionnaire_arr[$questionnaire->id] = $questionnaire->ref . ' - ' . $questionnaire->title;
					}
				}

				$formquestion = array(
					array('type' => 'select', 'tdclass' => 'titlefieldcreate', 'name' => 'questionnaire_id', 'label' => $langs->trans('RequestManagerSurvey'), 'values' => $questionnaire_arr, 'default' => $questionnaire_id),
					array('type' => 'date', 'tdclass' => 'titlefieldcreate', 'name' => 'date_answer_deadline', 'label' => $langs->trans('RequestManagerSetDateAnswerDeadline'), 'value' => $date_answer_deadline),
				);

				$formconfirm = $form->formconfirm($_SERVER["PHP_SELF"], $langs->trans('RequestManagerConfirmMassCreateSurvey'), $langs->trans($nb_selected > 0 ? 'RequestManagerConfirmMassCreateSurveyQuestion' : 'RequestManagerConfirmMassCreateSurveyAllQuestion', $nb_selected), 'confirm_rm_create_survey', $formquestion, '', 0, 200, 500, 1);
			}
			// Confirm send survey
			elseif ($massaction == 'pre_rm_send_survey' && isModEnabled('questionnaire')) {
				$questionnaire_id = GETPOST('questionnaire_id', 'int');
				$only_new = GETPOST('only_new', 'aZ09');
				$force_date_answer_deadline = GETPOST('force_date_answer_deadline', 'aZ09');
				$date_answer_deadline = dol_mktime(0, 0, 0, GETPOST('date_answer_deadlinemonth', 'int'), GETPOST('date_answer_deadlineday', 'int'), GETPOST('date_answer_deadlineyear', 'int'));

				$nb_selected = count($toselect);
//				$request_static = new RequestManager($db);
//				$questionnaires = $request->getRequestQuestionnaire();
//				$questionnaire = null;
//				if (is_array($questionnaires) && count($questionnaires) == 1) {
//					$questionnaire = array_values($questionnaires)[0];
//				}
				if ($date_answer_deadline === '') $date_answer_deadline = dol_now() + (/*is_object($questionnaire) && $questionnaire->answer_deadline > 0 ? $questionnaire->answer_deadline : */
					$conf->global->QUESTIONNAIRE_DEFAULT_ANSWER_DEADLINE) * 24 * 60 * 60;

				// Cree l'objet formulaire mail
				include_once DOL_DOCUMENT_ROOT . '/core/class/html.formmail.class.php';
				$formmail = new FormMail($db);
				$formmail->withform = 0;
				$formmail->withfrom = false;
				$formmail->withto = false;
				$formmail->withtouser = false;
				$formmail->withoptiononeemailperrecipient = false;
				$formmail->withtocc = false;
				$formmail->withtoccuser = false;
				$formmail->withtoccc = false;
				$formmail->withreplyto = false;
				$formmail->witherrorsto = false;
				$formmail->withdeliveryreceipt = false;
				$formmail->withfile = false;

				dol_include_once('/questionnaire/class/invitation.class.php');
				$invitation_user_static = new InvitationUser($db);
				// Make substitution in email content
				$substitutionarray = getCommonSubstitutionArray($langs, 1, null, $invitation_user_static);

				$substitutionarray['__CHECK_READ__'] = '__CHECK_READ__';
				$substitutionarray['__PERSONALIZED__'] = '__PERSONALIZED__';    // deprecated
				$substitutionarray['__CONTACTCIVNAME__'] = '__CONTACTCIVNAME__';

				$parameters = array(
					'mode' => 'formemail',
					'onlykey' => true,
				);
				complete_substitutions_array($substitutionarray, $langs, $invitation_user_static, $parameters);

				// Tableau des substitutions
				$formmail->substit = $substitutionarray;

				// Tableau des parametres complementaires du post
				$formmail->param['models'] = 'questionnaire';
				$formmail->param['models_id'] = GETPOST('modelmailselected', 'int');
				if (!empty($conf->global->MAILING_LIMIT_SENDBYWEB) && $nb_selected > $conf->global->MAILING_LIMIT_SENDBYWEB) {
					$langs->load("errors");
					setEventMessage(img_warning() . ' ' . $langs->trans('WarningNumberOfRecipientIsRestrictedInMassAction', $conf->global->MAILING_LIMIT_SENDBYWEB), 'errors');
				} else {
					$questionnaire_arr = array();
					if (is_array($questionnaires)) {
						foreach ($questionnaires as $questionnaire) {
							$questionnaire_arr[$questionnaire->id] = $questionnaire->ref . ' - ' . $questionnaire->title;
						}
					}
					$formquestion = array();

					if ($v13p) {
						$more_name = ',subject,message';
					} else {
						$more_name = '';
						$formquestion[] = array('name' => 'subject');
						$formquestion[] = array('name' => 'message');
					}
					$formquestion[] = array('type' => 'onecolumn', 'name' => 'modelselected' . $more_name, 'value' => $formmail->get_form());

					$formquestion[] = array('type' => 'other', 'tdclass' => 'titlefieldcreate', 'name' => 'questionnaire_id', 'label' => $langs->trans('RequestManagerSurvey'), 'value' => $form->selectarray('questionnaire_id', $questionnaire_arr, $questionnaire_id));

					if ($v13p) {
						$more_name = ',date_answer_deadline,date_answer_deadlineday,date_answer_deadlinemonth,date_answer_deadlineyear,date_answer_deadlinehour,date_answer_deadlinemin';
					} else {
						$more_name = '';
						$formquestion[] = array('name' => 'date_answer_deadline');
						$formquestion[] = array('name' => 'date_answer_deadlineday');
						$formquestion[] = array('name' => 'date_answer_deadlinemonth');
						$formquestion[] = array('name' => 'date_answer_deadlineyear');
						$formquestion[] = array('name' => 'date_answer_deadlinehour');
						$formquestion[] = array('name' => 'date_answer_deadlinemin');
					}
					$formquestion[] = array('type' => 'other', 'tdclass' => 'titlefieldcreate', 'name' => 'force_date_answer_deadline', 'label' => $form->textwithpicto($langs->trans('RequestManagerSetDateAnswerDeadline'), $langs->trans('RequestManagerSetDateAnswerDeadlineHelp')), 'value' => '<input type="checkbox" id="force_date_answer_deadline" name="force_date_answer_deadline"' . ($force_date_answer_deadline ? ' selected="selected"' : '') . '> ' . $form->select_date($date_answer_deadline, 'date_answer_deadline', 0, 0, 0, '', 1, 0, 1));

					$formquestion[] = array('type' => 'checkbox', 'tdclass' => 'titlefieldcreate', 'name' => 'only_new', 'label' => $form->textwithpicto($langs->trans('RequestManagerSendOnlyToNewInvitation'), $langs->trans('RequestManagerSendOnlyToNewInvitationHelp')), 'value' => !empty($only_new));

					$formconfirm = $form->formconfirm($_SERVER["PHP_SELF"], $langs->trans('RequestManagerConfirmMassSendSurvey'), $langs->trans($nb_selected > 0 ? 'RequestManagerConfirmMassSendSurveyQuestion' : 'RequestManagerConfirmMassSendSurveyAllQuestion', $nb_selected), 'confirm_rm_send_survey', $formquestion, '', 0, 200, 500, 1);
					$formconfirm .= <<<SCRIPT
	<script type="text/javascript">
		jQuery(document).ready(function() {
			jQuery("#subject").closest('tr').find('td:first').addClass('titlefieldcreate');
		});
	</script>
SCRIPT;
				}
			}
		}
		// Confirm delete
		if ($massaction == 'pre_rm_delete') {
			$delete_event_auto = GETPOST('delete_event_auto', 'aZ09');
			$delete_event_manual = GETPOST('delete_event_manual', 'aZ09');

			$formquestion = array(
				array('type' => 'checkbox', 'name' => 'delete_event_auto', 'label' => $langs->trans('RequestManagerDeleteAlsoLinkedAutoEvent'), 'value' => !empty($delete_event_auto)),
				array('type' => 'checkbox', 'name' => 'delete_event_manual', 'label' => $langs->trans('RequestManagerDeleteAlsoLinkedManualEvent'), 'value' => !empty($delete_event_manual)),
			);

			$formconfirm = $form->formconfirm($_SERVER["PHP_SELF"] . $params2, $langs->trans('RequestManagerDeleteRequest'), $langs->trans('RequestManagerConfirmDeleteRequest', $object->ref), 'confirm_rm_delete', $formquestion, '', 0, 200, 500, 1);
		}

		// Hook
		$parameters = array();
		$reshook = $hookmanager->executeHooks('formConfirm', $parameters, $object, $action); // Note that $action and $object may have been modified by hook
		if (empty($reshook)) $formconfirm.=$hookmanager->resPrint;
		elseif ($reshook > 0) $formconfirm=$hookmanager->resPrint;

		// Print form confirm
		print $formconfirm;

		if ($sall) {
            foreach ($fieldstosearchall as $key => $val) $fieldstosearchall[$key] = $langs->trans($val);
            print $langs->trans("FilterOnInto", $sall) . join(', ', $fieldstosearchall);
        }

        $i = 0;

        $moreforfilter = '';

        // Filter on users in charge
        if ($planning) {
            $moreforfilter .= '<div class="divsearchfield">';
            $moreforfilter .= $langs->trans('RequestManagerPlanningUsersInCharge') . ': ';
            $moreforfilter .= $formrequestmanager->multiselect_dolusers($search_in_charge, 'search_in_charge', '', 0, '', array(), 0, 0, 0, 'AND fk_soc IS NULL', 0, '', 'minwidth300');
            $moreforfilter .= '</div>';
        }

        //$moreforfilter.='<div class="divsearchfield">';
        //$moreforfilter.=$langs->trans('RequestManagerType'). ': ';
        //$moreforfilter.=$formrequestmanager->select_type(null,  $search_type, 'search_type', 1, 0, array(), 0, 0, ' minwidth200', ' multiple');
        //$moreforfilter.='</div>';

        $moreforfilter .= '<div class="divsearchfield">';
        $moreforfilter .= $langs->trans('Status') . ': ';
        $statut_array = array();
        $rmtypedictionary = Dictionary::getDictionary($db, 'requestmanager', 'requestmanagerrequesttype');
        $rmtypedictionary->fetch_lines(1);
        $rmstatusdictionary = Dictionary::getDictionary($db, 'requestmanager', 'requestmanagerstatus');
        $rmstatusdictionary->fetch_lines(1);
        $unknown_label = $langs->trans('Unknown') . ': ';
        foreach ($rmstatusdictionary->lines as $line) {
            $type_list = is_array($line->fields['request_type']) ? $line->fields['request_type'] : (is_string($line->fields['request_type']) ? explode(',', $line->fields['request_type']) : array());
            $toprint = array();
            foreach ($type_list as $type_id) {
                if (empty($planning) || (in_array($type_id, $request_types_planned) && $line->id == $conf->global->{'REQUESTMANAGER_PLANNING_REQUEST_STATUS_TO_PLAN_' . $type_id})) {
                    $toprint[] = isset($rmtypedictionary->lines[$type_id]) ? $rmtypedictionary->lines[$type_id]->fields['label'] : $unknown_label . $type_id;
                }
            }
            if ($planning && empty($toprint)) continue;
            $statut_array[$line->id] = $line->fields['label'] . (count($toprint) > 0 ? ' ( ' . implode(', ', $toprint) . ' )' : '');
        }
        $moreforfilter .= $form->multiselectarray('search_status_det', $statut_array, $search_status_det, 0, 0, ' minwidth300');
        $moreforfilter .= '</div>';

        // Filter on tags/categories
        if (isModEnabled('categorie')) {
            $moreforfilter .= '<div class="divsearchfield">';
            $moreforfilter .= $langs->trans('RequestManagerTags') . ': ';
            $moreforfilter .= $formrequestmanager->multiselect_categories($search_tags, 'search_tags', '', 0, 'minwidth300');
            $moreforfilter .= '</div>';
        }

        // Filter don't show children request
        $moreforfilter .= '<div class="divsearchfield">';
        $moreforfilter .= $langs->trans('RequestManagerDontShowChildrenRequest') . ': ';
        $moreforfilter .= $form->selectyesno('search_dont_show_children_request', $search_dont_show_children_request, 1);
        $moreforfilter .= '</div>';

        $parameters = array();
        $reshook = $hookmanager->executeHooks('printFieldPreListTitle', $parameters);    // Note that $action and $object may have been modified by hook
        if (empty($reshook)) $moreforfilter .= $hookmanager->resPrint;
        else $moreforfilter = $hookmanager->resPrint;

        if (!empty($moreforfilter)) {
            print '<div class="liste_titre liste_titre_bydiv centpercent">';
            print $moreforfilter;
            print '</div>';
        }

        $varpage = empty($contextpage) ? $_SERVER["PHP_SELF"] : $contextpage;
        $selectedfields = $form->multiSelectArrayWithCheckbox('selectedfields', $arrayfields, $varpage);    // This also change content of $arrayfields
        if ($massactionbutton) $selectedfields .= $form->showCheckAddButtons('checkforselect', 1);

        print '<div class="div-table-responsive">';
        print '<table class="tagtable nobottomiftotal liste' . ($moreforfilter ? " listwithfilterbefore" : "") . '">' . "\n";

        print '<tr class="liste_titre_filter">';
        // Ref
        if (!empty($arrayfields['rm.ref']['checked'])) {
            print '<td class="liste_titre">';
            print '<input class="flat" size="6" type="text" name="search_ref" value="' . dol_escape_htmltag($search_ref) . '">';
            print '</td>';
        }
        //External Ref
        if (!empty($arrayfields['rm.ref_ext']['checked'])) {
            print '<td class="liste_titre">';
            print '<input class="flat" size="6" type="text" name="search_ref_ext" value="' . dol_escape_htmltag($search_ref_ext) . '">';
            print '</td>';
        }
        // Type
        if (!empty($arrayfields['rm.fk_type']['checked'])) {
            print '<td class="liste_titre">';
            print '<input class="flat" size="6" type="text" name="search_type" value="' . dol_escape_htmltag($search_type) . '">';
            print '</td>';
        }
        // Category
        if (!empty($arrayfields['rm.fk_category']['checked'])) {
            print '<td class="liste_titre">';
            print '<input class="flat" size="6" type="text" name="search_category" value="' . dol_escape_htmltag($search_category) . '">';
            print '</td>';
        }
        // Label
        if (!empty($arrayfields['rm.label']['checked'])) {
            print '<td class="liste_titre">';
            print '<input class="flat" size="6" type="text" name="search_label" value="' . dol_escape_htmltag($search_label) . '">';
            print '</td>';
        }
        // Thridparty Origin
        if (!empty($arrayfields['rm.fk_soc']['checked'])) {
            print '<td class="liste_titre">';
            print '<input class="flat" size="6" type="text" name="search_thridparty_origin" value="' . dol_escape_htmltag($search_thridparty_origin) . '">';
            print '</td>';
        }
		// Requester contacts
		if (!empty($arrayfields['requester_contacts']['checked'])) {
			print '<td class="liste_titre">';
			print '<input class="flat" size="6" type="text" name="search_requester_contacts" value="' . dol_escape_htmltag($search_requester_contacts) . '">';
			print '</td>';
		}
        // Description
        if (!empty($arrayfields['rm.description']['checked'])) {
            print '<td class="liste_titre">';
            print '<input class="flat" size="6" type="text" name="search_description" value="' . dol_escape_htmltag($search_description) . '">';
            print '</td>';
        }
        // Source
        if (!empty($arrayfields['rm.fk_source']['checked'])) {
            print '<td class="liste_titre">';
            print '<input class="flat" size="6" type="text" name="search_source" value="' . dol_escape_htmltag($search_source) . '">';
            print '</td>';
        }
        // Urgency
        if (!empty($arrayfields['rm.fk_urgency']['checked'])) {
            print '<td class="liste_titre">';
            print '<input class="flat" size="6" type="text" name="search_urgency" value="' . dol_escape_htmltag($search_urgency) . '">';
            print '</td>';
        }
        // Impact
        if (!empty($arrayfields['rm.fk_impact']['checked'])) {
            print '<td class="liste_titre">';
            print '<input class="flat" size="6" type="text" name="search_impact" value="' . dol_escape_htmltag($search_impact) . '">';
            print '</td>';
        }
        // Priority
        if (!empty($arrayfields['rm.fk_priority']['checked'])) {
            print '<td class="liste_titre">';
            print '<input class="flat" size="6" type="text" name="search_priority" value="' . dol_escape_htmltag($search_priority) . '">';
            print '</td>';
        }
        // Estimated Duration
        if (!empty($arrayfields['rm.estimated_duration']['checked'])) {
            print '<td class="liste_titre right">';
//            print '<input class="flat" size="6" type="text" name="search_estimated_duration" value="' . dol_escape_htmltag($search_estimated_duration) . '">';
            print '</td>';
        }
        // Effective Duration
        if (!empty($arrayfields['rm.effective_duration']['checked'])) {
            print '<td class="liste_titre right">';
//            print '<input class="flat" size="6" type="text" name="search_effective_duration" value="' . dol_escape_htmltag($search_effective_duration) . '">';
            print '</td>';
        }
        // Reported Progress
        if (!empty($arrayfields['rm.reported_progress']['checked'])) {
             print '<td class="liste_titre right">';
//             print '<input class="flat" size="6" type="text" name="search_reported_progress" value="' . dol_escape_htmltag($search_reported_progress) . '">';
             print '</td>';
         }
        // Calculated progression
        if (!empty($arrayfields['calculated_progression']['checked'])) {
            print '<td class="liste_titre right">';
            print '</td>';
        }
        // Effective cost
        if (!empty($arrayfields['rm.effective_cost']['checked'])) {
            print '<td class="liste_titre right">';
            print '</td>';
        }
        // Date Operation
        if (!empty($arrayfields['rm.date_operation']['checked'])) {
            print '<td class="liste_titre center">';
            print '<input class="flat" size="6" type="text" name="search_date_operation" value="' . dol_escape_htmltag($search_date_operation) . '">';
            print '</td>';
        }
        // Date Deadline
        if (!empty($arrayfields['rm.date_deadline']['checked'])) {
            print '<td class="liste_titre center">';
            print '<input class="flat" size="6" type="text" name="search_date_deadline" value="' . dol_escape_htmltag($search_date_deadline) . '">';
            print '</td>';
        }
        // Notification requesters
        if (!empty($arrayfields['rm.notify_requester_by_email']['checked'])) {
            print '<td class="liste_titre center">';
            print $form->selectyesno('search_notify_assigned_by_email', $search_notify_assigned_by_email, 1, 0, 1);
            print '</td>';
        }
        // Notification watchers
        if (!empty($arrayfields['rm.notify_watcher_by_email']['checked'])) {
            print '<td class="liste_titre center">';
            print $form->selectyesno('search_notify_assigned_by_email', $search_notify_assigned_by_email, 1, 0, 1);
            print '</td>';
        }
        // Users in charge
        if (!empty($arrayfields['users_in_charge']['checked'])) {
            print '<td class="liste_titre">';
            print '</td>';
        }
        // Assigned user
        if (!empty($arrayfields['assigned_users']['checked'])) {
            print '<td class="liste_titre">';
            print '<input class="flat" size="6" type="text" name="search_assigned_user" value="' . dol_escape_htmltag($search_assigned_user) . '">';
            print '</td>';
        }
        // Assigned usergroup
        if (!empty($arrayfields['assigned_usergroups']['checked'])) {
            print '<td class="liste_titre">';
            print '<input class="flat" size="6" type="text" name="search_assigned_usergroup" value="' . dol_escape_htmltag($search_assigned_usergroup) . '">';
            print '</td>';
        }
        // Notification assigned
        if (!empty($arrayfields['rm.notify_assigned_by_email']['checked'])) {
            print '<td class="liste_titre center">';
            print $form->selectyesno('search_notify_assigned_by_email', $search_notify_assigned_by_email, 1, 0, 1);
            print '</td>';
        }
        // Reason for resolution
        if (!empty($arrayfields['rm.fk_reason_resolution']['checked'])) {
            print '<td class="liste_titre">';
            print $formdictionary->select_dictionary('requestmanager', 'requestmanagerreasonresolution', $search_reason_resolution, 'search_reason_resolution', 1);
            print '</td>';
        }
        // Details reason for resolution
        if (!empty($arrayfields['rm.reason_resolution_details']['checked'])) {
            print '<td class="liste_titre">';
            print '<input class="flat" size="6" type="text" name="search_reason_resolution_details" value="' . dol_escape_htmltag($search_reason_resolution_details) . '">';
            print '</td>';
        }
        // User resolved
        if (!empty($arrayfields['rm.fk_user_resolved']['checked'])) {
            print '<td class="liste_titre">';
            print '<input class="flat" size="6" type="text" name="search_user_resolved" value="' . dol_escape_htmltag($search_user_resolved) . '">';
            print '</td>';
        }
        // User closed
        if (!empty($arrayfields['rm.fk_user_closed']['checked'])) {
            print '<td class="liste_titre">';
            print '<input class="flat" size="6" type="text" name="search_user_cloture" value="' . dol_escape_htmltag($search_user_cloture) . '">';
            print '</td>';
        }
        // Date resolved
        if (!empty($arrayfields['rm.date_resolved']['checked'])) {
            print '<td class="liste_titre center">';
            print '<input class="flat" size="6" type="text" name="search_date_resolved" value="' . dol_escape_htmltag($search_date_resolved) . '">';
            print '</td>';
        }
        // Date closed
        if (!empty($arrayfields['rm.date_cloture']['checked'])) {
            print '<td class="liste_titre center">';
            print '<input class="flat" size="6" type="text" name="search_date_cloture" value="' . dol_escape_htmltag($search_date_cloture) . '">';
            print '</td>';
        }
        // Author
        if (!empty($arrayfields['rm.fk_user_author']['checked'])) {
            print '<td class="liste_titre">';
            print '<input class="flat" size="6" type="text" name="search_user_author" value="' . dol_escape_htmltag($search_user_author) . '">';
            print '</td>';
        }
        // Modified by
        if (!empty($arrayfields['rm.fk_user_modif']['checked'])) {
            print '<td class="liste_titre">';
            print '<input class="flat" size="6" type="text" name="search_user_modification" value="' . dol_escape_htmltag($search_user_modification) . '">';
            print '</td>';
        }
		// Extra fields
		include DOL_DOCUMENT_ROOT.'/core/tpl/extrafields_list_search_input.tpl.php';
        // Fields from hook
        $parameters = array('arrayfields' => $arrayfields);
        $reshook = $hookmanager->executeHooks('printFieldListOption', $parameters);    // Note that $action and $object may have been modified by hook
        print $hookmanager->resPrint;
        // Date creation
        if (!empty($arrayfields['rm.datec']['checked'])) {
            print '<td class="liste_titre center">';
            print '<input class="flat" size="6" type="text" name="search_date_creation" value="' . dol_escape_htmltag($search_date_creation) . '">';
            print '</td>';
        }
        // Date modification
        if (!empty($arrayfields['rm.tms']['checked'])) {
            print '<td class="liste_titre center">';
            print '<input class="flat" size="6" type="text" name="search_date_modification" value="' . dol_escape_htmltag($search_date_modification) . '">';
            print '</td>';
        }
        // Status
        if (!empty($arrayfields['rm.fk_status']['checked'])) {
            print '<td class="liste_titre maxwidthonsmartphone right">';
            print $form->selectarray('status_type', array(-2 => $langs->trans('RequestManagerTypeNotResolved'), RequestManager::STATUS_TYPE_INITIAL => $langs->trans('RequestManagerTypeInitial'), RequestManager::STATUS_TYPE_IN_PROGRESS => $langs->trans('RequestManagerTypeInProgress'), RequestManager::STATUS_TYPE_RESOLVED => $langs->trans('RequestManagerTypeResolved'), RequestManager::STATUS_TYPE_CLOSED => $langs->trans('RequestManagerTypeClosed')), $status_type, 1);
            print '</td>';
        }
        // Action column
        print '<td class="liste_titre" align="middle">';
        $searchpicto = $form->showFilterButtons();
        print $searchpicto;
        print '</td>';

        print "</tr>\n";

        // Fields title
        print '<tr class="liste_titre">';
        if (!empty($arrayfields['rm.ref']['checked'])) print_liste_field_titre($arrayfields['rm.ref']['label'], $_SERVER["PHP_SELF"], 'rm.ref', '', $param, '', $sortfield, $sortorder);
        if (!empty($arrayfields['rm.ref_ext']['checked'])) print_liste_field_titre($arrayfields['rm.ref_ext']['label'], $_SERVER["PHP_SELF"], 'rm.ref_ext', '', $param, '', $sortfield, $sortorder);
        if (!empty($arrayfields['rm.fk_type']['checked'])) print_liste_field_titre($arrayfields['rm.fk_type']['label'], $_SERVER["PHP_SELF"], 'crmrt.label', '', $param, '', $sortfield, $sortorder);
        if (!empty($arrayfields['rm.fk_category']['checked'])) print_liste_field_titre($arrayfields['rm.fk_category']['label'], $_SERVER["PHP_SELF"], 'crmc.label', '', $param, '', $sortfield, $sortorder);
        if (!empty($arrayfields['rm.label']['checked'])) print_liste_field_titre($arrayfields['rm.label']['label'], $_SERVER["PHP_SELF"], 'rm.label', '', $param, '', $sortfield, $sortorder);
        if (!empty($arrayfields['rm.fk_soc']['checked'])) print_liste_field_titre($arrayfields['rm.fk_soc']['label'], $_SERVER["PHP_SELF"], 's.nom', '', $param, '', $sortfield, $sortorder);
		if (!empty($arrayfields['requester_contacts']['checked'])) print_liste_field_titre($arrayfields['requester_contacts']['label'], $_SERVER["PHP_SELF"], '', '', $param, '', $sortfield, $sortorder);
		if (!empty($arrayfields['rm.description']['checked'])) print_liste_field_titre($arrayfields['rm.description']['label'], $_SERVER["PHP_SELF"], 'rm.description', '', $param, '', $sortfield, $sortorder);
        if (!empty($arrayfields['rm.fk_source']['checked'])) print_liste_field_titre($arrayfields['rm.fk_source']['label'], $_SERVER["PHP_SELF"], 'crms.label', '', $param, '', $sortfield, $sortorder);
        if (!empty($arrayfields['rm.fk_urgency']['checked'])) print_liste_field_titre($arrayfields['rm.fk_urgency']['label'], $_SERVER["PHP_SELF"], 'crmu.label', '', $param, '', $sortfield, $sortorder);
        if (!empty($arrayfields['rm.fk_impact']['checked'])) print_liste_field_titre($arrayfields['rm.fk_impact']['label'], $_SERVER["PHP_SELF"], 'crmi.label', '', $param, '', $sortfield, $sortorder);
        if (!empty($arrayfields['rm.fk_priority']['checked'])) print_liste_field_titre($arrayfields['rm.fk_priority']['label'], $_SERVER["PHP_SELF"], 'crmp.label', '', $param, '', $sortfield, $sortorder);
        if (!empty($arrayfields['rm.estimated_duration']['checked'])) print_liste_field_titre($arrayfields['rm.estimated_duration']['label'], $_SERVER["PHP_SELF"], /*'rm.estimated_duration'*/'', '', $param, '', $sortfield, $sortorder, 'right ');
        if (!empty($arrayfields['rm.effective_duration']['checked'])) print_liste_field_titre($arrayfields['rm.effective_duration']['label'], $_SERVER["PHP_SELF"], /*'rm.effective_duration'*/'', '', $param, '', $sortfield, $sortorder, 'right ');
        if (!empty($arrayfields['rm.reported_progress']['checked'])) print_liste_field_titre($arrayfields['rm.reported_progress']['label'], $_SERVER["PHP_SELF"], /*'rm.reported_progress'*/'', '', $param, '', $sortfield, $sortorder, 'right ');
        if (!empty($arrayfields['calculated_progression']['checked'])) print_liste_field_titre($arrayfields['calculated_progression']['label'], $_SERVER["PHP_SELF"], '', '', $param, '', $sortfield, $sortorder, 'right ');
        if (!empty($arrayfields['rm.effective_cost']['checked'])) print_liste_field_titre($arrayfields['rm.effective_cost']['label'], $_SERVER["PHP_SELF"], '', '', $param, '', $sortfield, $sortorder, 'right ');
        if (!empty($arrayfields['rm.date_operation']['checked'])) print_liste_field_titre($arrayfields['rm.date_operation']['label'], $_SERVER["PHP_SELF"], 'rm.date_operation', '', $param, '', $sortfield, $sortorder, 'center ');
        if (!empty($arrayfields['rm.date_deadline']['checked'])) print_liste_field_titre($arrayfields['rm.date_deadline']['label'], $_SERVER["PHP_SELF"], 'rm.date_deadline', '', $param, '', $sortfield, $sortorder, 'center ');
        if (!empty($arrayfields['rm.notify_requester_by_email']['checked'])) print_liste_field_titre($arrayfields['rm.notify_requester_by_email']['label'], $_SERVER["PHP_SELF"], 'rm.notify_requester_by_email', '', $param, '', $sortfield, $sortorder, 'center ');
        if (!empty($arrayfields['rm.notify_watcher_by_email']['checked'])) print_liste_field_titre($arrayfields['rm.notify_watcher_by_email']['label'], $_SERVER["PHP_SELF"], 'rm.notify_watcher_by_email', '', $param, '', $sortfield, $sortorder, 'center ');
        if (!empty($arrayfields['users_in_charge']['checked'])) print_liste_field_titre($arrayfields['users_in_charge']['label'], $_SERVER["PHP_SELF"], '', '', $param, '', $sortfield, $sortorder);
        if (!empty($arrayfields['assigned_users']['checked'])) print_liste_field_titre($arrayfields['assigned_users']['label'], $_SERVER["PHP_SELF"], '', '', $param, '', $sortfield, $sortorder);
        if (!empty($arrayfields['assigned_usergroups']['checked'])) print_liste_field_titre($arrayfields['assigned_usergroups']['label'], $_SERVER["PHP_SELF"], '', '', $param, '', $sortfield, $sortorder);
        if (!empty($arrayfields['rm.notify_assigned_by_email']['checked'])) print_liste_field_titre($arrayfields['rm.notify_assigned_by_email']['label'], $_SERVER["PHP_SELF"], 'rm.notify_assigned_by_email', '', $param, '', $sortfield, $sortorder, 'center ');
        if (!empty($arrayfields['rm.fk_reason_resolution']['checked'])) print_liste_field_titre($arrayfields['rm.fk_reason_resolution']['label'], $_SERVER["PHP_SELF"], 'crmrr.label', '', $param, '', $sortfield, $sortorder);
        if (!empty($arrayfields['rm.reason_resolution_details']['checked'])) print_liste_field_titre($arrayfields['rm.reason_resolution_details']['label'], $_SERVER["PHP_SELF"], 'rm.reason_resolution_details', '', $param, '', $sortfield, $sortorder);
        if (!empty($arrayfields['rm.fk_user_resolved']['checked'])) print_liste_field_titre($arrayfields['rm.fk_user_resolved']['label'], $_SERVER["PHP_SELF"], 'ur.lastname', '', $param, '', $sortfield, $sortorder);
        if (!empty($arrayfields['rm.fk_user_closed']['checked'])) print_liste_field_titre($arrayfields['rm.fk_user_closed']['label'], $_SERVER["PHP_SELF"], 'uc.lastname', '', $param, '', $sortfield, $sortorder);
        if (!empty($arrayfields['rm.date_resolved']['checked'])) print_liste_field_titre($arrayfields['rm.date_resolved']['label'], $_SERVER["PHP_SELF"], 'rm.date_resolved', '', $param, '', $sortfield, $sortorder, 'center ');
        if (!empty($arrayfields['rm.date_cloture']['checked'])) print_liste_field_titre($arrayfields['rm.date_cloture']['label'], $_SERVER["PHP_SELF"], 'rm.date_cloture', '', $param, '', $sortfield, $sortorder, 'center ');
        if (!empty($arrayfields['rm.fk_user_author']['checked'])) print_liste_field_titre($arrayfields['rm.fk_user_author']['label'], $_SERVER["PHP_SELF"], 'ua.lastname', '', $param, '', $sortfield, $sortorder);
        if (!empty($arrayfields['rm.fk_user_modif']['checked'])) print_liste_field_titre($arrayfields['rm.fk_user_modif']['label'], $_SERVER["PHP_SELF"], 'um.lastname', '', $param, '', $sortfield, $sortorder);
		// Extra fields
		include DOL_DOCUMENT_ROOT.'/core/tpl/extrafields_list_search_title.tpl.php';
        // Hook fields
        $parameters = array('arrayfields' => $arrayfields);
        $reshook = $hookmanager->executeHooks('printFieldListTitle', $parameters);    // Note that $action and $object may have been modified by hook
        print $hookmanager->resPrint;
        if (!empty($arrayfields['rm.datec']['checked'])) print_liste_field_titre($arrayfields['rm.datec']['label'], $_SERVER["PHP_SELF"], "rm.datec", "", $param, '', $sortfield, $sortorder, 'nowrap center ');
        if (!empty($arrayfields['rm.tms']['checked'])) print_liste_field_titre($arrayfields['rm.tms']['label'], $_SERVER["PHP_SELF"], "rm.tms", "", $param, '', $sortfield, $sortorder, 'nowrap center ');
        if (!empty($arrayfields['rm.fk_status']['checked'])) print_liste_field_titre($arrayfields['rm.fk_status']['label'], $_SERVER["PHP_SELF"], "crmst.label", "", $param, '', $sortfield, $sortorder, 'right ');
        print_liste_field_titre($selectedfields, $_SERVER["PHP_SELF"], "", '', '', '', $sortfield, $sortorder, 'center maxwidthsearch ');
        print '</tr>' . "\n";

        $users_cache = array();
        $usergroups_cache = array();
		$contact_cache = array();

        $now = dol_now();
        $i = 0;
        $totalarray = array();
		$totalarray['nbfield'] = 0;
        while ($i < min($num, $limit)) {
            $obj = $db->fetch_object($resql);

            $societestatic_origin->id = $obj->fk_soc;
            $societestatic_origin->name = $obj->soc_name_origin;
			$societestatic_origin->name_alias = $obj->soc_name_alias_origin;
            $societestatic_origin->client = $obj->soc_client_origin;
            $societestatic_origin->fournisseur = $obj->soc_fournisseur_origin;
            $societestatic_origin->code_client = $obj->soc_code_client_origin;
            $societestatic_origin->code_fournisseur = $obj->soc_code_fournisseur_origin;

            $objectstatic->id = $obj->rowid;
            $objectstatic->fk_parent = $obj->fk_parent;
            $objectstatic->ref = $obj->ref;
            $objectstatic->ref_ext = $obj->ref_ext;
            $objectstatic->fk_type = $obj->fk_type;
            $objectstatic->fk_urgency = $obj->fk_urgency;
            $objectstatic->label = $obj->label;
            $objectstatic->socid = $obj->fk_soc;
            $objectstatic->thirdparty = $societestatic;
            $objectstatic->date_deadline = $db->jdate($obj->date_deadline);

            // picto warning for deadline
            $pictoWarning = '';
            if ($objectstatic->date_deadline) {
                if ($objectstatic->date_deadline < $now) {
                    // alert time is up
                    $pictoWarning = ' ' . img_warning($langs->trans("Late"));
                }
            }

            print '<tr class="oddeven">';

            // Ref
            if (!empty($arrayfields['rm.ref']['checked'])) {
                print '<td class="nowrap">';
                print $objectstatic->getNomUrl(1, 'parent_path', 24) . $pictoWarning;
                print '</td>';
				if (! $i) $totalarray['nbfield']++;
            }
            //External Ref
            if (!empty($arrayfields['rm.ref_ext']['checked'])) {
                print '<td class="nowrap">';
                print $obj->ref_ext;
                print '</td>';
				if (! $i) $totalarray['nbfield']++;
            }
            // Type
            if (!empty($arrayfields['rm.fk_type']['checked'])) {
                print '<td class="nowrap">';
                print $obj->type_label;
                print '</td>';
				if (! $i) $totalarray['nbfield']++;
            }
            // Category
            if (!empty($arrayfields['rm.fk_category']['checked'])) {
                print '<td class="nowrap">';
                print $obj->category_label;
                print '</td>';
				if (! $i) $totalarray['nbfield']++;
            }
            // Label
            if (!empty($arrayfields['rm.label']['checked'])) {
                print '<td>';
                $toprint = dol_trunc($obj->label, 24);
                if (empty($conf->global->MAIN_DISABLE_TRUNC)) {
                    $toprint = $form->textwithtooltip($toprint, $obj->label);
                }
                print $toprint;
                print '</td>';
				if (! $i) $totalarray['nbfield']++;
            }
            // Thridparty Origin
            if (!empty($arrayfields['rm.fk_soc']['checked'])) {
                print '<td class="nowrap">';
                print $societestatic_origin->getNomUrl(1, '', 24);
                print '</td>';
				if (! $i) $totalarray['nbfield']++;
            }
			// Requester contacts
			if (!empty($arrayfields['requester_contacts']['checked'])) {
				print '<td>';
				$requester_contacts = explode(',', $obj->requester_contacts);
				if (is_array($requester_contacts) && count($requester_contacts) > 0) {
					$toprint = array();
					foreach ($requester_contacts as $contact_id) {
						if ($contact_id > 0) {
							if (!isset($contact_cache[$contact_id])) {
								$contact = new Contact($db);
								$contact->fetch($contact_id);
								$contact_cache[$contact_id] = $contact;
							}
							$toprint[] = '<span class="nowrap">' . $contact_cache[$contact_id]->getNomUrl(1) . '</span>';
						}
					}
					print implode(', ', $toprint);
				}
				print '</td>';
				if (! $i) $totalarray['nbfield']++;
			}
            // Description
            if (!empty($arrayfields['rm.description']['checked'])) {
                print '<td>';
                $toprint = dol_trunc($obj->description, 24);
                if (empty($conf->global->MAIN_DISABLE_TRUNC)) {
                    $toprint = $form->textwithtooltip($toprint, $obj->description);
                }
                print $toprint;
                print '</td>';
				if (! $i) $totalarray['nbfield']++;
            }
            // Source
            if (!empty($arrayfields['rm.fk_source']['checked'])) {
                print '<td class="nowrap">';
                print $obj->source_label;
                print '</td>';
				if (! $i) $totalarray['nbfield']++;
            }
            // Urgency
            if (!empty($arrayfields['rm.fk_urgency']['checked'])) {
                $color = $objectstatic->getColorUrgency();
                print '<td class="nowrap"' . (empty($color) ? '' : ' style="background-color: ' . $color . ' !important;"') . '>';
                print $obj->urgency_label;
                print '</td>';
				if (! $i) $totalarray['nbfield']++;
            }
            // Impact
            if (!empty($arrayfields['rm.fk_impact']['checked'])) {
                print '<td class="nowrap">';
                print $obj->impact_label;
                print '</td>';
				if (! $i) $totalarray['nbfield']++;
            }
            // Priority
            if (!empty($arrayfields['rm.fk_priority']['checked'])) {
                print '<td class="nowrap">';
                print $obj->priority_label;
                print '</td>';
				if (! $i) $totalarray['nbfield']++;
            }
            if (!empty($arrayfields['rm.estimated_duration']['checked']) ||
                !empty($arrayfields['rm.effective_duration']['checked']) ||
                !empty($arrayfields['rm.reported_progress']['checked'])) {
                $can_set_times = $objectstatic->isRequestTypeOption('display_set_times');
                $children_total_time_spent = $objectstatic->get_children_total_time_spent();
            }
            // Estimated Duration
            if (!empty($arrayfields['rm.estimated_duration']['checked'])) {
                print '<td class="nowrap right">';
                $estimated_duration = $obj->estimated_duration + $children_total_time_spent['total_estimated_duration'];
                if ($estimated_duration > 0) print convertSecondToTime($estimated_duration, 'allhourmin');
                print '</td>';
				if (! $i) $totalarray['nbfield']++;
				if (! $i) $totalarray['totalestimateddurationfield']=$totalarray['nbfield'];
				$totalarray['totalestimatedduration'] += $estimated_duration;
            }
            // Effective Duration
            if (!empty($arrayfields['rm.effective_duration']['checked'])) {
                print '<td class="nowrap right">';
                $effective_duration = $obj->effective_duration + $obj->total_effective_duration + $children_total_time_spent['total_effective_duration'];
                if ($effective_duration > 0) print convertSecondToTime($effective_duration, 'allhourmin');
                print '</td>';
				if (! $i) $totalarray['nbfield']++;
				if (! $i) $totalarray['totaleffectivedurationfield']=$totalarray['nbfield'];
				$totalarray['totaleffectiveduration'] += $effective_duration;
            }
            // Reported Progress
            if (!empty($arrayfields['rm.reported_progress']['checked'])) {
                print '<td class="nowrap right">';
                $reported_progress = $children_total_time_spent['total_reported_progress'] > 0 ? ($can_set_times && isset($obj->reported_progress) ? ($obj->reported_progress + $children_total_time_spent['total_reported_progress']) / 2 : $children_total_time_spent['total_reported_progress']) : $obj->reported_progress;
                if ($reported_progress > 0) print price($reported_progress) . ' %';
                print '</td>';
				if (! $i) $totalarray['nbfield']++;
				if (! $i) $totalarray['totalreportedprogressfield']=$totalarray['nbfield'];
				if ($reported_progress > 0) {
					$totalarray['totalreportedprogress'] += $reported_progress;
					$totalarray['totalreportedprogresscount']++;
				}
            }
            // Calculated progression
            if (!empty($arrayfields['calculated_progression']['checked'])) {
                print '<td class="nowrap right">';
                $estimated_duration = $obj->estimated_duration + $children_total_time_spent['total_estimated_duration'];
                $effective_duration = $obj->effective_duration + $obj->total_effective_duration + $children_total_time_spent['total_effective_duration'];
                if ($estimated_duration > 0) {
					$calculated_progression = $effective_duration > 0 ? round($effective_duration / $estimated_duration * 100, 2) : 0;
                    print price($calculated_progression) . ' %';
                } else {
                	$calculated_progression = 0;
                    print '<span class="opacitymedium">' . $langs->trans('RequestManagerEffectiveDurationNotDefined') . '</span>';
                }
                print '</td>';
				if (! $i) $totalarray['nbfield']++;
				if (! $i) $totalarray['totalcalculatedprogressionfield']=$totalarray['nbfield'];
				if ($estimated_duration > 0) {
					$totalarray['totalcalculatedprogression'] += $calculated_progression;
					$totalarray['totalcalculatedprogressioncount']++;
				}
            }
            // Effective cost
            if (!empty($arrayfields['rm.effective_cost']['checked'])) {
                print '<td class="nowrap right">';
                $effective_cost = $obj->effective_cost + $children_total_time_spent['total_effective_cost'];
                if (!empty($effective_cost)) print price($effective_cost, '', $langs, 1, 0, 0, $conf->currency);
                print '</td>';
				if (! $i) $totalarray['nbfield']++;
				if (! $i) $totalarray['totaleffectivecostfield']=$totalarray['nbfield'];
				$totalarray['totaleffectivecost'] += $effective_cost;
            }
            // Date Operation
            if (!empty($arrayfields['rm.date_operation']['checked'])) {
                print '<td class="nowrap" align="center">';
                if ($obj->date_operation > 0) print dol_print_date($db->jdate($obj->date_operation), 'dayhour');
                print '</td>';
				if (! $i) $totalarray['nbfield']++;
            }
            // Date Deadline
            if (!empty($arrayfields['rm.date_deadline']['checked'])) {
                print '<td class="nowrap" align="center">';
                if ($obj->date_deadline > 0) print dol_print_date($db->jdate($obj->date_deadline), 'dayhour');
                print '</td>';
				if (! $i) $totalarray['nbfield']++;
            }
            // Notification requesters
            if (!empty($arrayfields['rm.notify_requester_by_email']['checked'])) {
                print '<td class="nowrap" align="center">';
                print yn($obj->notify_requester_by_email);
                print '</td>';
				if (! $i) $totalarray['nbfield']++;
            }
            // Notification watchers
            if (!empty($arrayfields['rm.notify_watcher_by_email']['checked'])) {
                print '<td class="nowrap" align="center">';
                print yn($obj->notify_watcher_by_email);
                print '</td>';
				if (! $i) $totalarray['nbfield']++;
            }
            // Users in charge
            if (!empty($arrayfields['users_in_charge']['checked'])) {
                print '<td>';
                $users_in_charge = explode(',', $obj->users_in_charge);
                if (is_array($users_in_charge) && count($users_in_charge) > 0) {
                    $toprint = array();
                    $blocktoprint = array();
                    foreach ($users_in_charge as $user_id) {
                        if ($user_id > 0) {
                            if (!isset($users_cache[$user_id])) {
                                $user_in_charge = new User($db);
                                $user_in_charge->fetch($user_id);
                                $users_cache[$user_id] = $user_in_charge;
                            }
                            $blocktoprint[] = '<span class="nowrap">' . $users_cache[$user_id]->getNomUrl(1) . '</span>';
                        }
                        if (count($blocktoprint) == 5) { // split nb of users into a line
                            $toprint[] = implode(', ', $blocktoprint);
                            $blocktoprint = array();
                        }
                    }
                    if (count($blocktoprint)) $toprint[] = implode(', ', $blocktoprint);
                    print implode('<br>', $toprint);
                }
                print '</td>';
				if (! $i) $totalarray['nbfield']++;
            }
            // Assigned user
            if (!empty($arrayfields['assigned_users']['checked'])) {
                print '<td>';
                $assigned_users = explode(',', $obj->assigned_users);
                if (is_array($assigned_users) && count($assigned_users) > 0) {
                    $toprint = array();
                    foreach ($assigned_users as $user_id) {
                        if ($user_id > 0) {
                            if (!isset($users_cache[$user_id])) {
                                $assigned_user = new User($db);
                                $assigned_user->fetch($user_id);
                                $users_cache[$user_id] = $assigned_user;
                            }
                            $toprint[] = '<span class="nowrap">' . $users_cache[$user_id]->getNomUrl(1) . '</span>';
                        }
                    }
                    print implode(', ', $toprint);
                }
                print '</td>';
				if (! $i) $totalarray['nbfield']++;
            }
            // Assigned usergroup
            if (!empty($arrayfields['assigned_usergroups']['checked'])) {
                print '<td>';
                $assigned_usergroups = explode(',', $obj->assigned_usergroups);
                if (is_array($assigned_usergroups) && count($assigned_usergroups) > 0) {
                    $toprint = array();
                    foreach ($assigned_usergroups as $usergroup_id) {
                        if (!isset($usergroups_cache[$usergroup_id])) {
                            $assigned_usergroup = new UserGroup($db);
                            $assigned_usergroup->fetch($usergroup_id);
                            $usergroups_cache[$usergroup_id] = $assigned_usergroup;
                        }
                        $toprint[] = '<span class="nowrap">' . $usergroups_cache[$usergroup_id]->getFullName($langs) . '</span>';
                    }
                    print implode(', ', $toprint);
                }
                print '</td>';
				if (! $i) $totalarray['nbfield']++;
            }
            // Notification assigned
            if (!empty($arrayfields['rm.notify_assigned_by_email']['checked'])) {
                print '<td class="nowrap center">';
                print yn($obj->notify_assigned_by_email);
                print '</td>';
				if (! $i) $totalarray['nbfield']++;
            }
            // Reason for resolution
            if (!empty($arrayfields['rm.fk_reason_resolution']['checked'])) {
                print '<td class="nowrap">';
                print $obj->reason_resolution;
                print '</td>';
				if (! $i) $totalarray['nbfield']++;
            }
            // Details reason for resolution
            if (!empty($arrayfields['rm.reason_resolution_details']['checked'])) {
                print '<td class="nowrap">';
                print $obj->reason_resolution_details;
                print '</td>';
				if (! $i) $totalarray['nbfield']++;
            }
            // User resolved
            if (!empty($arrayfields['rm.fk_user_resolved']['checked'])) {
                print '<td class="nowrap">';
                if ($obj->fk_user_resolved > 0) {
                    $userstatic->id = $obj->fk_user_resolved;
                    $userstatic->firstname = $obj->userresolvedfirstname;
                    $userstatic->lastname = $obj->userresolvedlastname;
                    $userstatic->email = $obj->userresolvedemail;
                    print $userstatic->getNomUrl(1);
                }
                print '</td>';
				if (! $i) $totalarray['nbfield']++;
            }
            // User closed
            if (!empty($arrayfields['rm.fk_user_closed']['checked'])) {
                print '<td class="nowrap">';
                if ($obj->fk_user_closed > 0) {
                    $userstatic->id = $obj->fk_user_closed;
                    $userstatic->firstname = $obj->userclosedfirstname;
                    $userstatic->lastname = $obj->userclosedlastname;
                    $userstatic->email = $obj->userclosedemail;
                    print $userstatic->getNomUrl(1);
                }
                print '</td>';
				if (! $i) $totalarray['nbfield']++;
            }
            // Date resolved
            if (!empty($arrayfields['rm.date_resolved']['checked'])) {
                print '<td class="nowrap" align="center">';
                if ($obj->date_resolved > 0) print dol_print_date($db->jdate($obj->date_resolved), 'dayhour');
                print '</td>';
				if (! $i) $totalarray['nbfield']++;
            }
            // Date closed
            if (!empty($arrayfields['rm.date_cloture']['checked'])) {
                print '<td class="nowrap" align="center">';
                if ($obj->date_closed > 0) print dol_print_date($db->jdate($obj->date_closed), 'dayhour');
                print '</td>';
				if (! $i) $totalarray['nbfield']++;
            }
            // Author
            if (!empty($arrayfields['rm.fk_user_author']['checked'])) {
                print '<td class="nowrap">';
                if ($obj->fk_user_author > 0) {
                    $userstatic->id = $obj->fk_user_author;
                    $userstatic->firstname = $obj->userauthorfirstname;
                    $userstatic->lastname = $obj->userauthorlastname;
                    $userstatic->email = $obj->userauthoremail;
                    print $userstatic->getNomUrl(1);
                }
                print '</td>';
				if (! $i) $totalarray['nbfield']++;
            }
            // Modified by
            if (!empty($arrayfields['rm.fk_user_modif']['checked'])) {
                print '<td class="nowrap">';
                if ($obj->fk_user_modif > 0) {
                    $userstatic->id = $obj->fk_user_modif;
                    $userstatic->firstname = $obj->usermodiffirstname;
                    $userstatic->lastname = $obj->usermodiflastname;
                    $userstatic->email = $obj->usermodifemail;
                    print $userstatic->getNomUrl(1);
                }
                print '</td>';
				if (! $i) $totalarray['nbfield']++;
            }

			// Extra fields
			include DOL_DOCUMENT_ROOT.'/core/tpl/extrafields_list_print_fields.tpl.php';
            // Fields from hook
            $parameters = array('arrayfields' => $arrayfields, 'obj' => $obj);
            $reshook = $hookmanager->executeHooks('printFieldListValue', $parameters);    // Note that $action and $object may have been modified by hook
            print $hookmanager->resPrint;

            // Date creation
            if (!empty($arrayfields['rm.datec']['checked'])) {
                print '<td align="center" class="nowrap">';
                print dol_print_date($db->jdate($obj->datec), 'dayhour');
                print '</td>';
				if (! $i) $totalarray['nbfield']++;
            }
            // Date modification
            if (!empty($arrayfields['rm.tms']['checked'])) {
                print '<td align="center" class="nowrap">';
                print dol_print_date($db->jdate($obj->tms), 'dayhour');
                print '</td>';
				if (! $i) $totalarray['nbfield']++;
            }
            // Status
            if (!empty($arrayfields['rm.fk_status']['checked'])) {
                print '<td align="right" class="nowrap">' . $objectstatic->LibStatut($obj->fk_status, 5, 0, !empty($conf->global->REQUESTMANAGER_SHOW_CHILDREN_REQUEST_STATUS_IN_LIST) ? 3 : -1) . '</td>';
				if (! $i) $totalarray['nbfield']++;
            }

            // Action column
            print '<td class="nowrap" align="center">';
            if ($planning && $user->rights->requestmanager->planning->manage) {
                print '<a href="' . $_SERVER['PHP_SELF'] . '?action=to_plan&request_id=' . $obj->rowid . '&token=' . newToken() . $param . '">';
                print img_object($langs->trans("RequestManagerPlanningToPlan"), "action");
                print '</a>&nbsp;';
            }
            if ($massactionbutton || $massaction)   // If we are in select mode (massactionbutton defined) or if we have already selected and sent an action ($massaction) defined
            {
                $selected = 0;
                if (in_array($obj->rowid, $arrayofselected)) $selected = 1;
                print '<input id="cb' . $obj->rowid . '" class="flat checkforselect" type="checkbox" name="toselect[]" value="' . $obj->rowid . '"' . ($selected ? ' checked="checked"' : '') . '>';
            }
            print '</td>';
			if (! $i) $totalarray['nbfield']++;

            print "</tr>\n";

            $i++;
        }

		$parameters = array('arrayfields' => $arrayfields, 'totalarray' => $totalarray);
		$reshook = $hookmanager->executeHooks('printFieldListTotal', $parameters);    // Note that $action and $object may have been modified by hook
		if (empty($reshook)) {
			// Show total line
			if (isset($totalarray['totalestimateddurationfield'])
				|| isset($totalarray['totaleffectivedurationfield'])
				|| isset($totalarray['totalreportedprogressfield'])
				|| isset($totalarray['totalcalculatedprogressionfield'])
				|| isset($totalarray['totaleffectivecostfield'])
				|| isset($totalarray['totalizable'])
			) {
				print '<tr class="liste_total">';
				$i = 0;
				while ($i < $totalarray['nbfield']) {
					$i++;
					if ($i == 1) {
						if ($num < $limit && empty($offset)) print '<td class="left">' . $langs->trans("Total") . '</td>';
						else print '<td class="left">' . $langs->trans("Totalforthispage") . '</td>';
					} elseif ($totalarray['totalestimateddurationfield'] == $i) print '<td class="nowrap right">' . convertSecondToTime($totalarray['totalestimatedduration'], 'allhourmin') . '</td>';
					elseif ($totalarray['totaleffectivedurationfield'] == $i) print '<td class="nowrap right">' . convertSecondToTime($totalarray['totaleffectiveduration'], 'allhourmin') . '</td>';
					elseif ($totalarray['totalreportedprogressfield'] == $i) print '<td class="nowrap right">' . price($totalarray['totalreportedprogress'] / $totalarray['totalreportedprogresscount']) . ' %</td>';
					elseif ($totalarray['totalcalculatedprogressionfield'] == $i) print '<td class="nowrap right">' . price($totalarray['totalcalculatedprogression'] / $totalarray['totalcalculatedprogressioncount']) . ' %</td>';
					elseif ($totalarray['totaleffectivecostfield'] == $i) print '<td class="nowrap right">' . price($totalarray['totaleffectivecost'], '', $langs, 1, 0, 0, $conf->currency) . '</td>';
					elseif ($totalarray['totalizable']) {
						$printed = false;
						foreach ($totalarray['totalizable'] as $totalizable) {
							if ($totalizable['pos'] == $i && !$printed) {
								print '<td class="nowrap right">' . price($totalizable['total']) . '</td>';
								$printed = true;
							}
						}
						if (!$printed) {
							print '<td></td>';
						}
					} else print '<td></td>';
				}
				print '</tr>';
			}
		}

        $db->free($resql);

        $parameters = array('arrayfields' => $arrayfields, 'sql' => $sql);
        $reshook = $hookmanager->executeHooks('printFieldListFooter', $parameters);    // Note that $action and $object may have been modified by hook
        print $hookmanager->resPrint;

        print '</table>' . "\n";
        print '</div>' . "\n";

        print '</form>' . "\n";
    } else {
        dol_print_error($db);
    }
} else {
    print $langs->trans('RequestManagerPlanningRequestTypeNotConfigured');
}

// End of page
llxFooter();
$db->close();
