-- ============================================================================
-- Copyright (C) 2018	 Open-DSI 	 <support@open-dsi.fr>
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program. If not, see <http://www.gnu.org/licenses/>.
-- ===========================================================================

-- v4.0.0
ALTER TABLE `llx_requestmanager` ADD `total_ht`					        double(24,8) DEFAULT 0 COMMENT 'montant total ht apres remise globale';
ALTER TABLE `llx_requestmanager` ADD `tva`						          double(24,8) DEFAULT 0 COMMENT 'montant total tva apres remise globale';
ALTER TABLE `llx_requestmanager` ADD `localtax1`				        double(24,8) DEFAULT 0 COMMENT 'amount total localtax1';
ALTER TABLE `llx_requestmanager` ADD `localtax2`				        double(24,8) DEFAULT 0 COMMENT 'amount total localtax2';
ALTER TABLE `llx_requestmanager` ADD `total_ttc`			        	double(24,8) DEFAULT 0 COMMENT 'montant total ttc apres remise globale';
ALTER TABLE `llx_requestmanager` ADD `fk_multicurrency` 		    integer;
ALTER TABLE `llx_requestmanager` ADD `multicurrency_code` 		  varchar(255);
ALTER TABLE `llx_requestmanager` ADD `multicurrency_tx` 		    double(24,8) DEFAULT 1;
ALTER TABLE `llx_requestmanager` ADD `multicurrency_total_ht`	  double(24,8) DEFAULT 0;
ALTER TABLE `llx_requestmanager` ADD `multicurrency_total_tva`	double(24,8) DEFAULT 0;
ALTER TABLE `llx_requestmanager` ADD `multicurrency_total_ttc`	double(24,8) DEFAULT 0;

-- v4.0.1
ALTER TABLE llx_requestmanager DROP FOREIGN KEY fk_requestmanager_fk_assigned_user;
ALTER TABLE llx_requestmanager DROP FOREIGN KEY fk_requestmanager_fk_assigned_usergroup;
ALTER TABLE llx_requestmanager DROP INDEX idx_requestmanager_fk_assigned_user;
ALTER TABLE llx_requestmanager DROP INDEX idx_requestmanager_fk_assigned_usergroup;
ALTER TABLE llx_requestmanager DROP COLUMN fk_assigned_user;
ALTER TABLE llx_requestmanager DROP COLUMN fk_assigned_usergroup;
ALTER TABLE llx_requestmanager ADD date_operation	datetime;

-- v4.0.2
ALTER TABLE llx_requestmanager ADD fk_soc_origin	    integer NOT NULL; -- id of the thirdparty origin
ALTER TABLE llx_requestmanager ADD fk_soc_benefactor	integer NOT NULL; -- id of the thirdparty benefactor
ALTER TABLE llx_requestmanager ADD INDEX idx_requestmanager_fk_soc_origin (fk_soc_origin);
ALTER TABLE llx_requestmanager ADD INDEX idx_requestmanager_fk_soc_benefactor (fk_soc_benefactor);
ALTER TABLE llx_requestmanager ADD CONSTRAINT fk_requestmanager_fk_soc_origin         FOREIGN KEY (fk_soc_origin) REFERENCES llx_societe (rowid);
ALTER TABLE llx_requestmanager ADD CONSTRAINT fk_requestmanager_fk_soc_benefactor     FOREIGN KEY (fk_soc_benefactor) REFERENCES llx_societe (rowid);
UPDATE llx_requestmanager SET fk_soc_origin = fk_soc WHERE fk_soc_origin = 0;
UPDATE llx_requestmanager SET fk_soc_benefactor = fk_soc WHERE fk_soc_benefactor = 0;

-- v4.0.3
ALTER TABLE llx_requestmanager ADD fk_parent	    integer NULL; -- id of the parent request
ALTER TABLE llx_requestmanager ADD INDEX idx_requestmanager_fk_parent (fk_parent);
ALTER TABLE llx_requestmanager ADD CONSTRAINT fk_requestmanager_fk_parent         FOREIGN KEY (fk_parent) REFERENCES llx_requestmanager (rowid);

-- v4.0.4
ALTER TABLE llx_requestmanager_message DROP INDEX idx_requestmanager_message_fk_knowledge_base;
ALTER TABLE llx_requestmanager_message DROP COLUMN fk_knowledge_base;
ALTER TABLE llx_requestmanager_message ADD CONSTRAINT fk_requestmanager_m_fk_actioncomm FOREIGN KEY (fk_actioncomm) REFERENCES llx_actioncomm (id);
ALTER TABLE llx_requestmanager_message ADD notify_assigned    integer(1) NULL; -- notify assigned
ALTER TABLE llx_requestmanager_message ADD notify_requesters  integer(1) NULL; -- notify requesters
ALTER TABLE llx_requestmanager_message ADD notify_watchers    integer(1) NULL; -- notify watchers

-- v4.0.12
UPDATE llx_actioncomm_extrafields SET rm_ipbx_id=rm_ipbx;

-- v4.0.14
DROP VIEW IF EXISTS llx_requestmanager_internal_user_phone_book;
DROP VIEW IF EXISTS llx_requestmanager_soc_contact_phone_book;

-- v4.0.16
UPDATE llx_extrafields SET perms='0', label='IPBX' WHERE name = 'rm_ipbx_id' AND elementtype = 'actioncomm';

-- v4.0.17
ALTER TABLE llx_requestmanager ADD fk_reason_resolution         integer NULL;
ALTER TABLE llx_requestmanager ADD reason_resolution_details    text NULL;

-- v4.0.19
ALTER TABLE llx_requestmanager ADD fk_soc_watcher	integer; -- id of the thirdparty watcher
ALTER TABLE llx_requestmanager ADD INDEX idx_requestmanager_fk_soc_watcher (fk_soc_watcher);

-- v4.0.20
ALTER TABLE llx_requestmanager ADD availability_for_thirdparty_principal	integer; -- availability of the request for the thirdparty principal
ALTER TABLE llx_requestmanager ADD availability_for_thirdparty_benefactor	integer; -- availability of the request for the thirdparty benefactor
ALTER TABLE llx_requestmanager ADD availability_for_thirdparty_watcher	integer; -- availability of the request for the thirdparty watcher

-- v4.0.21
ALTER TABLE llx_requestmanager_message_knowledge_base ADD position integer NOT NULL DEFAULT 0; -- position
ALTER TABLE llx_requestmanager_message_knowledge_base DROP FOREIGN KEY fk_requestmanager_mkb_fk_actioncomm;
ALTER TABLE llx_requestmanager_message_knowledge_base DROP FOREIGN KEY fk_requestmanager_mkb_fk_knowledge_base;
ALTER TABLE llx_requestmanager_message_knowledge_base DROP INDEX uk_requestmanager_mkb;
ALTER TABLE llx_requestmanager_message_knowledge_base ADD UNIQUE INDEX uk_requestmanager_mkb (fk_actioncomm, position, fk_knowledge_base);
ALTER TABLE llx_requestmanager_message_knowledge_base ADD CONSTRAINT fk_requestmanager_mkb_fk_actioncomm      FOREIGN KEY (fk_actioncomm) REFERENCES llx_actioncomm (id);
ALTER TABLE llx_requestmanager_message_knowledge_base ADD CONSTRAINT fk_requestmanager_mkb_fk_knowledge_base  FOREIGN KEY (fk_knowledge_base) REFERENCES llx_c_requestmanager_knowledge_base (rowid);

-- v4.0.22
ALTER TABLE `llx_requestmanager` CHANGE COLUMN `description` `description`  text;

-- v4.0.23
DROP TABLE `llx_societe_rm_user_in_charge`;

-- v4.0.30
ALTER TABLE llx_requestmanager ADD estimated_duration           integer DEFAULT 0 NOT NULL;
ALTER TABLE llx_requestmanager CHANGE COLUMN `duration` `effective_duration`  integer DEFAULT 0 NOT NULL;
ALTER TABLE llx_requestmanager ADD total_effective_duration     integer DEFAULT 0 NOT NULL;
ALTER TABLE llx_requestmanager ADD reported_progress            integer NULL DEFAULT 0;
ALTER TABLE llx_requestmanager ADD effective_cost               double DEFAULT 0 NOT NULL;

-- v4.0.37
ALTER TABLE llx_requestmanager_time_spent DROP INDEX uk_requestmanager_ts;
ALTER TABLE llx_requestmanager_time_spent ADD INDEX idx_requestmanager_ts_fk_user_author (fk_user_author);
ALTER TABLE llx_requestmanager_time_spent ADD INDEX idx_requestmanager_ts_fk_user_modif (fk_user_modif);
ALTER TABLE llx_requestmanager_time_spent ADD CONSTRAINT fk_requestmanager_ts_fk_user_author    FOREIGN KEY (fk_user_author) REFERENCES llx_user (rowid);
ALTER TABLE llx_requestmanager_time_spent ADD CONSTRAINT fk_requestmanager_ts_fk_user_modif     FOREIGN KEY (fk_user_modif) REFERENCES llx_user (rowid);
ALTER TABLE llx_requestmanager_time_spent CHANGE COLUMN `tms` `tms` datetime DEFAULT NULL;
ALTER TABLE llx_requestmanager_time_spent ADD `time_date` datetime DEFAULT NULL AFTER fk_user;
ALTER TABLE llx_requestmanager_time_spent ADD `note`      text NULL AFTER time_date;
UPDATE llx_requestmanager As rm LEFT JOIN (SELECT fk_requestmanager, SUM(duration) AS total_duration, SUM(duration * thm / 3600) AS total_effective_cost FROM llx_requestmanager_time_spent GROUP BY fk_requestmanager) AS t ON t.fk_requestmanager = rm.rowid SET rm.total_effective_duration = t.total_duration, rm.effective_cost = t.total_effective_cost WHERE ts.time_date IS NULL;
DELETE FROM llx_requestmanager_time_spent WHERE duration = 0 AND ts.time_date IS NULL;
UPDATE llx_requestmanager_time_spent AS ts LEFT JOIN llx_user AS u ON u.rowid = ts.fk_user SET ts.thm = u.thm WHERE ts.time_date IS NULL;
UPDATE llx_requestmanager_time_spent SET datec = tms, time_date = DATE(datec) WHERE time_date IS NULL;

-- v4.0.42
ALTER TABLE llx_requestmanager DROP FOREIGN KEY fk_requestmanager_fk_soc_origin;
ALTER TABLE llx_requestmanager DROP FOREIGN KEY fk_requestmanager_fk_soc_benefactor;
ALTER TABLE llx_requestmanager DROP INDEX idx_requestmanager_fk_soc_origin;
ALTER TABLE llx_requestmanager DROP INDEX idx_requestmanager_fk_soc_benefactor;
ALTER TABLE llx_requestmanager DROP COLUMN fk_soc_origin;
ALTER TABLE llx_requestmanager DROP COLUMN fk_soc_benefactor;
ALTER TABLE llx_requestmanager CHANGE COLUMN `fk_soc` `fk_soc` integer;
ALTER TABLE llx_requestmanager DROP COLUMN fk_soc_watcher;
ALTER TABLE llx_requestmanager DROP COLUMN availability_for_thirdparty_principal;
ALTER TABLE llx_requestmanager DROP COLUMN availability_for_thirdparty_benefactor;
ALTER TABLE llx_requestmanager DROP COLUMN availability_for_thirdparty_watcher;

-- v4.0.44
ALTER TABLE llx_requestmanager ADD `model_pdf`      varchar(255) NULL AFTER fk_user_modif;
ALTER TABLE llx_requestmanager ADD `last_main_doc`  varchar(255) NULL AFTER model_pdf;
ALTER TABLE llx_requestmanager ADD `import_key`     varchar(14)  NULL AFTER last_main_doc;

-- v4.0.72
ALTER TABLE llx_requestmanager ADD `status_thread`      text NOT NULL AFTER fk_status;

-- v4.0.72
UPDATE llx_const SET name = 'REQUESTMANAGER_DISPLAY_BUTTON_CREATE_REQ_IN_TOP_MENU' WHERE name = 'REQUESTMANAGER_DISPLAY_BUTTON_CREATE_REQUEST_IN_TOP_MENU';
UPDATE llx_const SET name = 'REQUESTMANAGER_DISPLAY_BUTTON_CREATE_REQ_IN_TOP_RIGHT_MENU' WHERE name = 'REQUESTMANAGER_DISPLAY_BUTTON_CREATE_REQUEST_IN_TOP_RIGHT_MENU';