<?php
/* Copyright (C) 2018       Open-DSI      <support@open-dsi.fr>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

/**
 *  \file		htdocs/requestmanager/tpl/timesspentblock.tpl.php
 *  \ingroup	requestmanager
 *  \brief		Template to show times spent to request manager
 */

// Protection to avoid direct call of template
if (empty($conf) || ! is_object($conf))
{
	print "Error, template page can't be called as URL";
	exit;
}

?>

<!-- BEGIN PHP TEMPLATE -->

<?php

require_once DOL_DOCUMENT_ROOT . '/core/lib/date.lib.php';

global $user;

$langs = $GLOBALS['langs'];
$timesSpentBlock = $GLOBALS['timesSpentBlock'];
$objectID = $GLOBALS['objectID'];

foreach($timesSpentBlock as $key => $user_time_spent)
{
?>
    <tr class="oddeven">
      <td><?php echo $user_time_spent['user']->getNomUrl(1) ?></td>
      <td><?php echo ($user_time_spent['duration'] > 0 ? convertSecondToTime($user_time_spent['duration'], 'allhourmin') : '') ?></td>
      <td><?php echo ($user_time_spent['cost'] > 0 ? price($user_time_spent['cost'], '', $langs, 1, 0, 0, $conf->currency) : '') ?></td>
    </tr>
<?php
}
?>

<!-- END PHP TEMPLATE -->
